IMPLEMENTATION MODULE PullDown;

FROM Window   IMPORT WinDef,Use,GotoXY,TextColor,DirectWrite,WinType,Color,
                     CursorOff,FullScreen,CursorOn,TextBackground,WhereX;
FROM Str      IMPORT ItemS,Delete,Length,CharPos,Slice,RCharPos;
FROM IO       IMPORT WrStr,WrCharRep,WrCard,WrChar;
FROM EMouse   IMPORT ShowMouse,HideMouse,ButtonStatusAndPosition,Button,SoftwareTextMouse,
                     MouseInstalled;
FROM Lib      IMPORT ScanR,AddAddr,FatalError;
FROM Storage  IMPORT ALLOCATE,DEALLOCATE;
FROM IO       IMPORT KeyPressed,RdKey;

IMPORT Window;

CONST   Min    = 40;    (* Added to uuencode a number into a string
                           Must be >40, because ' is the separator *)
        Divver = 256-Min;  (* Space left per byte. *)
        DvD    = Divver*(Divver-1); (* Reserve upper "Min" values for
                                        callsigns Submenus *)
        ScrX   = 80;       (* Width of Screen. Fixed for TopSpeed,
                               since TopSpeed's Window is limited to 80 *)
        ScrY   = 25;       (* Idem for Screen depth*)

        NrTopMax=20;

        (* Some key-codes, as returned by GetKey*)

        ESC    =    1BH;                    ArrU   = 04800H;
        ArrL   = 04B00H;                    ArrR   = 04D00H;
        ArrD   = 05000H;                    CR     =     13;
        F1     = 3B00H;


(* Inline procedure, stops blinking of text, assembler. *)
(*Function ax=1003H  bl=0 int 10H, NOT ESSENTIAL, YOU CAN DELETE IT OR
USE YOUR OWN EQUIVALENT! If you delete it don't use colors
 Window.Color(8)..Window.Color(15). These will blink. Some IO/windowing
 modules run the following procedure by default.*)

CONST       (*%T _fcall *)    Ret = 0CBH; (*%E *)
            (*%F _fcall *)    Ret = 0C3H; (*%E *)

TYPE A12 = ARRAY[0..11] OF BYTE;

INLINE PROCEDURE BlinkOff=A12(50H,53H,0B8H,03H,10H,32H,0DBH,0CDH,10H,5BH,58H,Ret);
(*Inline off *)

TYPE   Set9           = SET OF [0..8];     (* Used to tell which winhandles are
                                              open *)
       BitSet         = SET OF [0..NrO];
       BitSet50       = SET OF [0..50];
       PositionsType  = ARRAY[0..NrTopMax] OF CARDINAL; (* Used to predefine
                                                      top-items, when automatic
                                                      calculation fails. Only
                                                      internal in this
                                                      version *)

       MouseRec       =  RECORD
                          X1,Y1,X2,Y2  :CARDINAL;
                          END;

       MouseDataRec= RECORD
                      Mouse      : ARRAY[0..10] OF MouseRec;
                      Active     : BOOLEAN;
                      DesLev     : CARDINAL;
                      DesField   : CARDINAL;
                      END;

         DataType=
           RECORD
            Top        : StType;              (* direct pointer to Topstring*)
            TopNr      : CARDINAL;            (* nr of items in top*)
            DefW,                             (* calculated X-positions
                                                 Top items*)
            Posi,                             (* The calculated or predefined
                                                  x positions of the topitems*)
            Size0      : PositionsType;       (* length topitems per menustring
                                                 Only Top menustring is parsed*)
            MaxW,                             (* widest word in each
                                                        menustring *)
            AantV                             (* items per menustring *)
                    : ARRAY[1..NrO] OF CARDINAL;
            WinHan  : ARRAY[0..8] OF WinType; (* Window Handles, 0 is Top,
                                                 1 is normal menu, 2 is 1st
                                                 submenu, 3 is 2nd submenu etc,
                                                 till maximal "Level" *)
            Flags   : ARRAY[0..10] OF BitSet50;
            WinOpen    : Set9      ;          (* Which handles of WinHan are
                                                  used now? *)

            MenuNr  : CARDINAL;               (* Nr of menustrings*)
            Menu    : ARRAY[1..NrO] OF StType;(* Pointers to each menustring*)
            MenSiz  : CARDINAL;               (* Menu.PullSize, see def
                                                  PullObject*)
            Level   : CARDINAL;               (* Recursion level.
                                                Top=0,Pull=1 Sub=2..22 *)
            Pull    : PullDef;                (* PullDef is defined and
                                                  commented in the DEF file*)
            Sub     : BOOLEAN;                  (* Submenu? *)
            END;

     PObjPoint     = POINTER TO DataType; (* Pointertype to record*)

VAR  Dat     : ARRAY[0..19] OF PObjPoint; (* several objects at once,
                                             PullHandle is index in this
                                             array *)
     Ms      : MouseDataRec;              (* Information about last mouse
                                              click*)
     Active  : BitSet;                    (* Which pointer in Dat are
                                             allocated?*)

CONST Shifted='{}&"'+'"';

PROCEDURE WriteSpecialStr(KeyCol,StanCol,StanBack:Color;VAR S:ARRAY OF CHAR;Max:CARDINAL):CHAR;
(* Parses a string for escape characters (colors, predefined keys, and
   outputs it colorful. Returns key if exists.
   KeyCol is the special color for predefined keys, standard color is
   normal color of the text*)

VAR A,B,Len : CARDINAL;
    Ret   : CHAR;

BEGIN
 TextColor(StanCol);
 Ret:=CHR(1);
 Len:=Length(S);
 IF Len=0 THEN
  RETURN Ret;
  END;
 DEC(Len);
 A:=0;
 LOOP
  IF A>(Len) THEN
   EXIT
   END;
  IF S[A]="" THEN
   WrCharRep(" ",2);
   END;
  IF S[A]="{" THEN
   Ret:=S[A+1];
   TextColor(KeyCol);
   WrChar(S[A+1]);
   TextColor(StanCol);
   INC(A);
   TextColor(StanCol);
  ELSIF S[A]="}" THEN
   B:=CARDINAL(S[A+1])-166;
   INC(A);
   IF B<16 THEN
    TextColor(Color(B));
   ELSIF (B=16) THEN
    TextColor(StanCol);
   ELSIF B=40 THEN
    WrCharRep(" ",3);
   ELSIF B=41 THEN
    WrCharRep(" ",ORD(S[A+1])-166);
    INC(A);
   ELSE
    WrChar(Shifted[B-17]);
    END;
  ELSIF S[A]="&" THEN
   B:=CARDINAL(S[A+1])-166;
   INC(A);
   TextBackground(Color(B));
  ELSIF (S[A] #"_") AND (S[A] # "") THEN
   WrChar(S[A]);
   END;
  INC(A);
  END;
 A:=WhereX();
 IF (A-3)<Max THEN
  WrCharRep(" ",Max-A+3);
  END;
 RETURN CAP(Ret);
END WriteSpecialStr;

PROCEDURE ClrScrF();
(* Clear Fullscreen, Window.Use current handle*)

VAR TempW:Window.WinType;

BEGIN
 TempW:=Window.Used();
 Use(Window.FullScreen);
 Window.Clear;
 Use(TempW);
END ClrScrF;

PROCEDURE GetMouseOrKey(H:PullHandle):CARDINAL;
(* This routine tests both key as mouse support. All keys are returned directly,
but mouseclicks only when they're somehow valid.
(in open windows on the selectable spots on the topbar)*)

VAR GA : CARDINAL;
    Da,B2 : Button;
    X,Y : CARDINAL;
    Bl,Bl2: BOOLEAN;
    A   : CARDINAL;
    Dx,Dy:CARDINAL;

BEGIN
 Ms.Active:=FALSE;
 LOOP
  IF KeyPressed() THEN
   GA:=ORD(RdKey());
   IF GA=0 THEN
    GA:=ORD(RdKey())<<8;
    END;
   EXIT
   END;
  Da:=ButtonStatusAndPosition(  X, Y );
  IF ORD(Da) # 0 THEN
   REPEAT
    B2:=ButtonStatusAndPosition(  Dx, Dy );
   UNTIL ORD(B2)=0;  (* Wait until mouse released*)
   END;
  IF Da=RightB THEN (* Right button works as ESC key*)
   GA:=ESC;
   EXIT
   END;
  IF Da=LeftB THEN (* Left button is real click*)
   Y:=Y>>3; X:=X>>3; (* Convert graph- to textscreenlocations*)
   IF Y=0 THEN
    FOR A:= 1 TO Dat[H]^.TopNr DO (* Clicked in TopBar?*)
     Dy:=Dat[H]^.Posi[A];
     Dx:=Dy+Dat[H]^.Size0[A];
     IF A # 1 THEN
      DEC(Dy);
      END;
     IF (X>(Dy)) AND (X<Dx) THEN
      Ms.DesLev:=0;
      Ms.Active:=TRUE;
      Ms.DesField:=A;
      RETURN MAX(CARDINAL)-1; (*Yes*)
      END;
     END;
    END;
   FOR A:=Dat[H]^.Level TO 1 BY -1 DO (* In Window*)
    Bl:=(X>Ms.Mouse[A].X1) AND (X<Ms.Mouse[A].X2);
    Bl2:=(Y>Ms.Mouse[A].Y1) AND (Y<Ms.Mouse[A].Y2);
    IF A=Dat[H]^.Level THEN
     IF Bl AND ((Y=Ms.Mouse[A].Y1) OR (Y=Ms.Mouse[A].Y2)) THEN
      Ms.Active:=FALSE;
      EXIT;                    (* Clicked on border highest level window,
                                   do nothing*)
      END;
     IF Bl2 AND ((X=Ms.Mouse[A].X1) OR (X=Ms.Mouse[A].X2)) THEN
      Ms.Active:=FALSE;
      EXIT;                    (* Clicked on border highest level window,
                                   do nothing*)
      END;
     END;
    IF Bl AND Bl2 THEN
     Ms.Active:=TRUE;                               (* Only exit with a
                                                       valid level.*)
     Ms.DesLev:=A;
     Ms.DesField:=Y-Ms.Mouse[A].Y1-1;
     IF Ms.DesField IN Dat[H]^.Flags[Dat[H]^.Level] THEN
      Ms.Active:=FALSE;                             (* Clicked on a |--|*)
      EXIT
      END;
     RETURN MAX(CARDINAL)-1;
     END;
    END;
   END;
  Use(FullScreen);
  END;
 RETURN GA;
END GetMouseOrKey;

PROCEDURE WakeUp(H:PullHandle);
(* Unhide all PullDown windows of handle(H) *)

VAR A : CARDINAL;

BEGIN
 WITH Dat[H]^ DO
 FOR A:= 0 TO Level DO
  IF A IN WinOpen THEN
   Window.PutOnTop(WinHan[A]);
   END;
  END;
 END;
END WakeUp;

PROCEDURE MakeObjIndex(Obj:ADDRESS;D:PObjPoint;Siz:CARDINAL);
(* Calculates/fills Menu and MenuNr records from raw menu data*)

VAR A,P : CARDINAL;

BEGIN
 IF Siz>6 THEN
  DEC(Siz,6);
  D^.MenuNr:=1;
  D^.Menu[1]:=Obj;
  P:=0;
  LOOP
   IF P> (Siz) THEN
    EXIT
    END;
   A:=ScanR(AddAddr(Obj,P),Siz-P+8,0);
   IF D^.MenuNr>NrO THEN
    EXIT
    END;
   IF A < (Siz-P) THEN
    INC(P,A+1);
    INC(D^.MenuNr);
    D^.Menu[D^.MenuNr]:=AddAddr(Obj,P);
   ELSE
    EXIT
    END;
  END;
  INC(D^.MenuNr);
  END;
END MakeObjIndex;

PROCEDURE Toggler(H:PullHandle;Label,Option:CARDINAL;OptionStr:ARRAY OF CHAR);

VAR First,Total,
    A,Len       : CARDINAL;
    S           : ARRAY[0..100] OF CHAR;
    St          : StType;

BEGIN
 St:=GetObjAddr(H,Label,Total);
 Slice (S,St^,0,Total);
 First:=CharPos(S,"_");
 IF First=MAX(CARDINAL) THEN
  RETURN;
  END;
 Total:=RCharPos(S,"_");
 IF Total=First THEN
  RETURN
  END;
 DEC(Total,First+1);
 ItemS(S,OptionStr,"@",Option);
 Len:=Length(S);
 IF (Len=0) OR (Len>200) THEN
  RETURN;
  END;
 IF Len> Total THEN
  RETURN;
  END;
 FOR A:=0 TO Len-1 DO
  St^[First+A+1]:=S[A];
  END;
 IF Total>Len THEN
  FOR A:=Len TO Total-1 DO
   St^[First+A+1]:=CHR(32);
   END;
  END;
END Toggler;

PROCEDURE OnOffItem(H:PullHandle;Label:CARDINAL);
(* Toggle the On/Off option on or off, this procedure is very strict, checking
    everything and a more loose procedure is mosttimes enough, since
    the label makes sure not everything is passed to this procedure.*)

VAR St : StType;
    S2 : ARRAY[0..100] OF CHAR;
    A : CARDINAL;

BEGIN
 St:=GetObjAddr(H,Label,A);
 Slice (S2,St^,0,A);
 A:=CharPos(S2,"_");
 IF CAP(S2[A+2])="F" THEN
  A:=1;
 ELSE
  A:=0;
  END;
 Toggler(H,Label,A,"off@on");
END OnOffItem;

PROCEDURE GetObjAddr(H:PullHandle;Label:CARDINAL;VAR Siz:CARDINAL):StType;
(* Get Address(pointer to string) and size of item "label" *)

VAR A,P,P2 : CARDINAL;
    D,St   : StType;

BEGIN
 Siz:=0;
 IF Dat[H]^.MenSiz>6 THEN
  D:=Dat[H]^.Menu[1];
  P:=0;
  LOOP
   IF (P+6)> (Dat[H]^.MenSiz) THEN
    RETURN NIL;
    END;
   A:=ScanR(AddAddr(D,P),Dat[H]^.MenSiz-P+6,"'");
   IF A < (Dat[H]^.MenSiz-P) THEN
    St:=AddAddr(D,P);
    P2:=(ORD(St^[A+1])-Min)*Divver+ORD(St^[A+2])-Min;
    IF P2=Label THEN
     St:=AddAddr(St,2);
     Siz:=CharPos(St^,"'");
     RETURN St;
     END;
    INC(P,A+3);
   ELSE
    RETURN NIL;
    END;
  END;
  END;
END GetObjAddr;

PROCEDURE GetObjItem(VAR S2:ARRAY OF CHAR;Y:CARDINAL;VAR S : ARRAY OF CHAR);
(* S2 not changed, VAR for size/speedup reasons *)
(* Get Y'nd item from S2, return in S with constant chars deleted*)

VAR A:CARDINAL;

BEGIN
 ItemS(S,S2,"'",Y);
 IF Y # 0 THEN
  Delete(S,0,2);
  END;
END GetObjItem;

PROCEDURE GetObjCode(VAR S2:ARRAY OF CHAR;Y:CARDINAL;VAR Code:CARDINAL);
(* S2 not changed, VAR for size/speedup reasons *)
(* Get Y'nd item from S2, calculate constant from constant chars,
   return constant in Code *)
VAR S : ARRAY[0..20] OF CHAR;

BEGIN
 ItemS(S,S2,"'",Y);
 Code:=Divver*(ORD(S[0])-Min)+ ORD(S[1])-Min;
END GetObjCode;

PROCEDURE Hilight(X,Y,Len:CARDINAL;FCol,BCol,KCol:Color;VAR St:ARRAY OF CHAR);
(* St not changed, VAR for size/speedup reasons *)
(* Write String St in color FCol and BCol to screenpositions (X,Y) (relative)
    and pad to length Len.*)

VAR A: CARDINAL;
    C: CHAR;

BEGIN
 HideMouse;
 IF (X=0) AND (Y>0) THEN X:=1; END;
 TextBackground(BCol);
 GotoXY(X,Y);
 C:=WriteSpecialStr(KCol,FCol,BCol,St,Len);
 TextColor(FCol);
 TextBackground(BCol);
 X:=WhereX();
 IF (X-3)<Len THEN
  WrCharRep(" ",Len-X+3);
  END;
 ShowMouse;
END Hilight;

PROCEDURE MenuHilight(X,Nr:CARDINAL;H:PullHandle;HiLight:BOOLEAN);
(* Hilight for normal menus. Get some data from PObjPoint first. *)

VAR S: ARRAY[0..80] OF CHAR;
    FCol,BCol : Color;

BEGIN
 WITH Dat[H]^ DO
  IF HiLight THEN
   FCol:=Pull.Cols.HiCol;BCol:=Pull.Cols.HiBack
  ELSE
   FCol:=Pull.Cols.Text;BCol:=Pull.Cols.InCol
   END;
  Use(WinHan[Level]);
  GetObjItem(Menu[Nr]^,X,S);
  Hilight(2,X+2,MaxW[Nr]-1,FCol,BCol,Pull.Cols.KeyCol,S);
 END;
END MenuHilight;

PROCEDURE TopHilight(Y:CARDINAL;H:PullHandle;Hil:BOOLEAN);
(* Hilight for Topmenu, get all data from Top records*)

VAR S: ARRAY[0..40] OF CHAR;
  VAR FCol,BCol:Color;

BEGIN
 WITH Dat[H]^ DO
  IF Hil THEN
   FCol:=Pull.Cols.HiTop;BCol:=Pull.Cols.HiBTop;
  ELSE
   FCol:=Pull.Cols.TextTop;BCol:=Pull.Cols.Top;
   END;
  Use(WinHan[0]);
  ItemS(S,Top^,"'",Y); (* No codes-constants in TopMenu, direct ItemS*)
  Hilight(Posi[Y]+1,0,Size0[Y]-1,FCol,BCol,Pull.Cols.KeyCol,S);
  END;
END TopHilight;

PROCEDURE WritePullD(H:PullHandle;VAR Keys:ARRAY OF CHAR;Nr:CARDINAL;OpenWin:BOOLEAN;Y,Positie:CARDINAL);
(* Put Menu Nr on screen with all details except hilighting,
   Used to write ALL menus, both from PullDown (procedure GetPullKey)
   and SubMenu (procedure SubMenu). *)

VAR Tel1        : CARDINAL;
    DStr        : ARRAY[0..79] OF CHAR;
    WD2         : WinDef;
    MaxVeld,
    NoVeld      : CARDINAL;
    St          : StType;
    C           : CHAR;         (* Temporarily until keysupport*)
    YCoord      : CARDINAL;

BEGIN
 HideMouse;
 WITH Dat[H]^ DO
  St:=Dat[H]^.Menu[Nr];
  NoVeld:=AantV[Nr];
  MaxVeld:=MaxW[Nr];
  YCoord:=Y;
  IF (Y+NoVeld+1)>ScrY THEN
   YCoord:=ScrY-NoVeld-2;
   END;
  END;
 (* Avoid menu disappearing from screen on left or right side. Leftover
     from old pulldown, don't know if it's needed, but it is safer to
     keep it. *)
 WITH Dat[H]^.Pull.Cols DO
 IF OpenWin THEN

  IF Positie+MaxVeld+1>(ScrX-1) THEN Positie:=(ScrX-1)-MaxVeld; END;
  IF Positie=0 THEN Positie:=1; END;
  (* Open a Window *)
  WD2.X1:=Positie-1;
  Ms.Mouse[Dat[H]^.Level].X1:=Positie-1;
  Ms.Mouse[Dat[H]^.Level].X2:=Positie+MaxVeld;
  WD2.X2:=Positie+MaxVeld;
  WD2.Y1:=YCoord;
  Ms.Mouse[Dat[H]^.Level].Y1:=YCoord;
  Ms.Mouse[Dat[H]^.Level].Y2:=YCoord+NoVeld;
  WD2.Y2:=YCoord+NoVeld;
  WD2.Foreground:=Rand;
  WD2.Background:=InCol;
  WD2.FrameOn   :=FALSE;
  WD2.Hidden    :=FALSE;
  Dat[H]^.WinHan[Dat[H]^.Level]:=Window.Open(WD2);
  Use(Dat[H]^.WinHan[Dat[H]^.Level]);
  END;
  TextColor(Rand);
  TextBackground(RandBack);
 FOR Tel1:=0 TO NoVeld-2 DO
  ItemS(DStr,St^,"'",Tel1);
  IF (Tel1#0) THEN
   Delete(DStr,0,2);
   END;
  TextColor(Rand);
  TextBackground(RandBack);
  IF DStr[0] # CHR(0)THEN
                           (* First character "|" ? Then make a Ĵ *)
   INCL(Dat[H]^.Flags[Dat[H]^.Level],Tel1);
   IF DStr[0]="$" THEN
    GotoXY(1,Tel1+2);
    WrStr(Style[2]);
    IF MaxVeld>1 THEN
     WrCharRep(Style[3],MaxVeld);
     END;
    WrStr(Style[1]);
    Keys[Tel1]:=CHR(1);
   ELSE                         (* else put the string to screen*)
     EXCL(Dat[H]^.Flags[Dat[H]^.Level],Tel1);
    TextColor(Rand);
    TextBackground(RandBack);
    GotoXY(1,Tel1+2);
    WrStr(Style[4]);
    TextBackground(InCol);
    IF DStr[0]="" THEN
     INCL(Dat[H]^.Flags[Dat[H]^.Level],Tel1);
     TextColor(Text);
     TextBackground(InCol);
     WrChar(" ");
     WrCharRep(CHR(196),MaxVeld-2);
     Keys[Tel1]:=CHR(1);
    ELSE
     Keys[Tel1]:=WriteSpecialStr(KeyCol,Text,InCol,DStr,MaxVeld);
     END;
    TextColor(Rand);
    TextBackground(RandBack);
    GotoXY(MaxVeld+2,Tel1+2);
    WrStr(Style[4]);
    END;
   END;
  END;
  (* Draw  and Ŀ . Partially with DirectWrite because I had problems with
   wrapping in Ts 1.17. *)
 GotoXY(1,NoVeld+1); WrStr(Style[5]); WrCharRep(Style[3],MaxVeld);
 DirectWrite(MaxVeld+2,NoVeld+1,ADR(Style[7]),1); (* To avoid wrap problems*)
 GotoXY(1,1); WrStr(Style[6]); WrCharRep(Style[3],MaxVeld); WrStr(Style[0]);
 END;
 ShowMouse;
END WritePullD;

PROCEDURE PullOpen(Menu : PullObject;InDef:PullDef):PullHandle;
(* Opens any PullDown object, either PullDown menu or SubMenu. *)

VAR
     A,B,Max             : CARDINAL;
     H                   : PullHandle;
     Flag                : BOOLEAN;
     DumStr              : ARRAY[0..79] OF CHAR;

CONST WTop=WinDef(0,0,ScrX-1,0,White,Black,FALSE,FALSE,TRUE,FALSE,"",Black,Black);

BEGIN
 (* Search next free "Handle"*)
 A:=0;
 LOOP
  IF NOT (A IN Active) THEN
   EXIT
   END;
  IF A=19 THEN
   ClrScrF;
   Window.Use(FullScreen);
   FatalError(" Too many open Pulldownmenus");
   EXIT
   END;
  INC(A);
  END;
 H:=PullHandle(A);
 INCL(Active,H);

 ALLOCATE(Dat[H],SIZE(DataType));
 Dat[H]^.WinOpen:=Set9(0);

 (* Sub or PullDownmenu? *)

 Dat[H]^.Sub:=FALSE;
 IF Menu.MenuAddr=NIL THEN
  Dat[H]^.Sub:=TRUE;
  END;

 Dat[H]^.Pull:=InDef;
 Dat[H]^.Top:=Menu.MenuAddr;
 MakeObjIndex(Menu.PullAddr,Dat[H],Menu.PullSize);
 Dat[H]^.MenSiz:=Menu.PullSize;

 CursorOff; BlinkOff;

 IF NOT Dat[H]^.Sub THEN
 (* Open Topmenu Window for pulldowns only. *)

  WITH Dat[H]^ DO
   WinHan[0]:=Window.Open(WTop);
   Ms.Mouse[0].X1:=0;
   Ms.Mouse[0].Y1:=0;
   Ms.Mouse[0].Y2:=0;
   Ms.Mouse[0].X2:=ScrX-1;
   INCL(WinOpen,0);
   END;
  TextColor(InDef.Cols.TextTop);
  TextBackground(InDef.Cols.Top);
  END;

  (* Count # of items & minimal width window, both per menu*)
  WITH Dat[H]^ DO
  GotoXY(1,1);
   FOR A:=1 TO MenuNr-1 DO
    MaxW[A]:=0;
    AantV[A]:=0;
    DefW[A]:=0;
    LOOP
     GetObjItem(Menu[A]^,AantV[A],DumStr);
     IF DumStr[0]=CHR(0) THEN
      INC(AantV[A]);
      EXIT
      END;
     IF (Length(DumStr)>MaxW[A])    THEN
      MaxW[A]:=Length(DumStr);
      END;
     INC(AantV[A]);
     END;
    END;
   IF NOT Dat[H]^.Sub THEN
   TopNr:=1; (* Count and calculate width Top items*)
   LOOP
    ItemS(DumStr,Top^,"'",TopNr);
    IF DumStr[0] = CHR(0) THEN
     EXIT
     END;
    Size0[TopNr]:=Length(DumStr);
    INC(TopNr);
    END;

  A:=0;
  FOR B:= 1 TO Dat[H]^.TopNr-1 DO     (* Total width top items *)
   INC(A,Dat[H]^.Size0[B]);
   END;

 (* Calculate space between top items, with PosiParam as argument *)
  Max:=(ScrX - A - Dat[H]^.Pull.PosiParam) DIV (Dat[H]^.TopNr-2);

  A:=0;
  FOR B:= 1 TO Dat[H]^.TopNr DO (* convert into x-coordinates*)
   Dat[H]^.Posi[B]:=A;
   INC(A,Dat[H]^.Size0[B]+Max);
   END;
 END; (* IF Sub *)
END; (*Width*)

RETURN H;
END PullOpen;

PROCEDURE PullClose(H:PullHandle);
(* Close all Window-handles and release memory*)

VAR A :CARDINAL;

BEGIN
 CursorOn;
 Use(FullScreen);
 FOR A:= 0 TO Dat[H]^.Level DO
  IF A IN Dat[H]^.WinOpen THEN
   Window.Close(Dat[H]^.WinHan[A]);
   END;
  END;
 DEALLOCATE(Dat[H],SIZE(DataType));
 EXCL(Active,H);
END PullClose;

PROCEDURE PullHide(H:PullHandle);
(* Hide a PullDown menu temporarily *)

VAR A :CARDINAL;

BEGIN
 IF H IN Active THEN
  CursorOn;
  Use(FullScreen);
  FOR A:= 0 TO Dat[H]^.Level DO
   IF A IN Dat[H]^.WinOpen THEN
    Window.Hide(Dat[H]^.WinHan[A]);
    END;
   END;
  END;
END PullHide;

PROCEDURE SetPositions(H:PullHandle;NewX:ARRAY OF BYTE);

VAR A : CARDINAL;

BEGIN
 FOR A :=0 TO HIGH(NewX) DO
  Dat[H]^.Posi[A+1]:=CARDINAL(NewX[A]);
  END;
END SetPositions;

PROCEDURE SubMenu(XIn,YIn:CARDINAL;H:PullHandle;Nr:CARDINAL):CARDINAL;
(* The procedure which handles navigating in a submenu, recursively *)

VAR Tek                 : CARDINAL;
    Terug               : CARDINAL;
    Xi                  : CARDINAL;
    A,B                 : CARDINAL;
    Keys                : ARRAY[0..30] OF CHAR;

PROCEDURE DoSubSelect;                     (* interface to Select procedure*)
BEGIN
 WITH Dat[H]^ DO
 IF Pull.SelectProc # NULLPROC THEN
  GetObjCode(Menu[Nr]^,Xi+1,A);
  A:=Pull.SelectProc(A,H)
  END;
  END;
END DoSubSelect;

BEGIN
 Xi:=0;
 WITH Dat[H]^ DO
  INC(Level);
  WritePullD(H,Keys,Nr,TRUE,YIn,XIn);
  INCL(WinOpen,Level);
  MenuHilight(Xi,Nr,H,TRUE);
  END;
 Use(FullScreen);
 IF NOT Ms.Active THEN
  DoSubSelect;
  END;
  WITH Dat[H]^ DO
   LOOP
    IF NOT Ms.Active THEN
     Tek:=GetMouseOrKey(H);
     FOR A:=0 TO AantV[Nr]-2 DO
      IF CAP(CHR(Tek))=Keys[A] THEN
       Tek:=CR;
       MenuHilight(Xi,Nr,H,FALSE);
       Xi:=A;
       MenuHilight(Xi,Nr,H,TRUE);
       END;
      END;
     END;
    IF Ms.Active THEN
     IF (Ms.DesLev # Level) THEN
      Terug:=MAX(CARDINAL)-1;
      EXIT;
      END;
     MenuHilight(Xi,Nr,H,FALSE);
     Xi:=Ms.DesField;
     IF Xi IN Dat[H]^.Flags[Level] THEN
      Xi:=0;
     ELSE
      Tek:=CR;
      END;
      Ms.Active:=FALSE;
      MenuHilight(Xi,Nr,H,TRUE);
     END;
    CASE Tek OF
     | F1        : IF Pull.HelpProc # NULLPROC THEN
                    GetObjCode(Menu[Nr]^,Xi+1,A);
                    A:=Pull.HelpProc(A,H)
                    END;
     | ESC       : Terug:=MAX(CARDINAL);
                   EXIT;
     | CR        : GetObjCode(Menu[Nr]^,Xi+1,A);
                   IF A>DvD THEN
                    Terug:=SubMenu(XIn+5,YIn+1,H,A-DvD);
                    IF Terug#MAX(CARDINAL)-1 THEN
                     Ms.Active:=FALSE;          (* Just for security*)
                     END;
                   ELSE
                    Window.Use(Window.FullScreen);
                    Terug:=Pull.ResultProc(A,H);
                    IF Terug=1 THEN
                     (*Window.Close(WinHan[Level]); *)
                     Use(WinHan[Level]);
                     WritePullD(H,Keys,Nr,FALSE,YIn,XIn);
                     MenuHilight(Xi,Nr,H,TRUE);
                     END;
                    IF NOT Ms.Active THEN
                     WakeUp(H);
                     END;
                    END;
     | ArrU      : IF Xi>0 THEN
                    MenuHilight(Xi,Nr,H,FALSE);
                    IF NOT((Xi-1) IN Flags[Level]) THEN
                     DEC(Xi,1);
                    ELSE
                     DEC(Xi,2);
                     END;
                   MenuHilight(Xi,Nr,H,TRUE);
                   END;
    | ArrD      : IF Xi<(AantV[Nr]-2) THEN
                    MenuHilight(Xi,Nr,H,FALSE);
                   IF NOT((Xi+1) IN Flags[Level]) THEN
                    INC(Xi,1);
                   ELSE
                    INC(Xi,2);
                    END;
                   MenuHilight(Xi,Nr,H,TRUE);
                   END;
   END; (* CASE *)
   DoSubSelect;

  END; (*LOOP *)
 HideMouse;
 Window.Close(WinHan[Level]);
 ShowMouse;
 EXCL(WinOpen,Level);
 DEC(Level);
 END; (*With *)

 (* Return value, MAX(CARDINAL)=Escape, MAX(CARDINAL)-1= Mouse pressed on lower
    level*)
 RETURN Terug;
END SubMenu;

PROCEDURE GetPullKey(H:PullHandle;StartTopNr:CARDINAL):CARDINAL;

VAR RealY,RealAantV     : CARDINAL;
    Temp                : CARDINAL;
    Tek                 : CARDINAL;
    Terug               : CARDINAL;
    DumStr              : ARRAY[0..100] OF CHAR;
    X                   : CARDINAL;
    Y                   : CARDINAL;
    NewLev              : CARDINAL;
    Keys                : ARRAY[0..30] OF CHAR;

PROCEDURE DoSelect;
BEGIN
 WITH Dat[H]^ DO
   GetObjCode(Menu[RealY]^,X+1,Temp);
   IF Pull.SelectProc # NULLPROC THEN
    Terug:=Pull.SelectProc(Temp,H)
    END;
   END;
END DoSelect;

PROCEDURE DoRealY;
(* RealY is index menudata of Y-Coord Y *)

BEGIN
  WITH Dat[H]^ DO
   RealY:=ORD(Top^[Y])-Min;
   RealAantV:=(AantV[RealY]-2);
   END;
END DoRealY;

PROCEDURE WritePD(H:PullHandle;OpenWin:BOOLEAN);
(* Interface layer between GetPullKey/SubMenu and WritePullD *)

VAR A  : CARDINAL;

BEGIN
 WITH Dat[H]^ DO
   A:=ORD(Top^[Y])-Min; (* similar to RealY calculation in GetPullKey*)
   IF OpenWin THEN
    INCL(WinOpen,1);
   ELSE
    Use(WinHan[1]);
    END;
   WritePullD(H,Keys,A,OpenWin,1,Posi[Y]);
 END;
END WritePD;

BEGIN
 ShowMouse;
 IF NOT (H IN Active) THEN
  FatalError(" Invalid PullHandle ");
  END;

Window.PutOnTop(Dat[H]^.WinHan[0]);
Window.Use(Dat[H]^.WinHan[0]);

GotoXY(1,1);
WrCharRep(" ",ScrX);
FOR Temp:=1 TO Dat[H]^.TopNr-1 DO
 ItemS(DumStr,Dat[H]^.Top^,"'",Temp);
 GotoXY(Dat[H]^.Posi[Temp]+1,0);
 WrStr(DumStr);
 END;

WITH Dat[H]^ DO
 Y:=1;
 IF StartTopNr<TopNr THEN
  Y:=StartTopNr;
  END;
 Level:=1;
 X:=DefW[Y];
 DoRealY;
 WritePD(H,TRUE);
 INCL(WinOpen,Level);
 MenuHilight(X,RealY,H,TRUE);
 IF Dat[H]^.Pull.HiBar=TRUE THEN
   TopHilight(Y,H,TRUE);
  END;
 END;
 Use(FullScreen);
 DoSelect;
 WITH Dat[H]^ DO
  LOOP
    IF NOT Ms.Active THEN
     Tek:=GetMouseOrKey(H);
     FOR Temp:=0 TO AantV[RealY]-2 DO
      IF CAP(CHR(Tek))=Keys[Temp] THEN
       Tek:=CR;
       MenuHilight(X,RealY,H,FALSE);
       X:=Temp;
       MenuHilight(X,RealY,H,TRUE);
       END;
      END;
     END;
    IF Ms.Active THEN
     IF Ms.DesLev=0 THEN
      HideMouse;
      TopHilight(Y,H,FALSE);
      Y:=Ms.DesField;
      X:=0;
      DoRealY;
      Window.Close(WinHan[1]);
      EXCL(WinOpen,1);
      WritePD(H,TRUE);
      MenuHilight(X,RealY,H,TRUE);
      IF Pull.HiBar=TRUE THEN
       TopHilight(Y,H,TRUE);
       END;
      Ms.Active:=FALSE;
      ShowMouse;
      Tek:=0;
     ELSE
      MenuHilight(X,RealY,H,FALSE);
      X:=Ms.DesField;
      IF X IN Dat[H]^.Flags[1] THEN
       X:=0;
      ELSE
       Tek:=CR;
       END;
      Ms.Active:=FALSE;
      MenuHilight(X,RealY,H,TRUE);
      END;
     END;
   DoRealY;
    CASE Tek OF
     | F1        : GetObjCode(Menu[RealY]^,X+1,Temp);
                   IF Pull.HelpProc # NULLPROC THEN
                     Terug:=Pull.HelpProc(Temp,H)
                    END;
     | ESC       : Terug:=MAX(CARDINAL);
                   EXIT;
     | CR        : GetObjCode(Menu[RealY]^,X+1,Temp);
                   IF Temp>DvD THEN
                    ShowMouse;
                    Terug:=SubMenu(Posi[Y]+5,X+2,H,Temp-DvD);
                   ELSE
                    Window.Use(Window.FullScreen);
                    Terug:=Pull.ResultProc(Temp,H);
                    IF Terug=1 THEN
                     WritePD(H,FALSE);
                     END;
                    MenuHilight(X,RealY,H,TRUE);
                    WakeUp(H);
                    ShowMouse;
                    END;
                    (* PullClose*)
     | ArrL      : IF Y>1 THEN
                   TopHilight(Y,H,FALSE);
                   DefW[Y]:=X;
                   DEC(Y);
                   X:=DefW[Y];
                   DoRealY;
                   Window.Close(WinHan[1]);
                   EXCL(WinOpen,1);
                   WritePD(H,TRUE);
                   MenuHilight(X,RealY,H,TRUE);
                   IF Pull.HiBar=TRUE THEN
                    TopHilight(Y,H,TRUE);
                    END;
                   END;
    | ArrR      : IF Y<(Dat[H]^.TopNr-1) THEN
                   TopHilight(Y,H,FALSE);
                   DefW[Y]:=X;
                   INC(Y);
                   X:=DefW[Y];
                   DoRealY;
                   Window.Close(WinHan[1]);
                   EXCL(WinOpen,1);
                   WritePD(H,TRUE);
                   MenuHilight(X,RealY,H,TRUE);
                   IF Pull.HiBar=TRUE THEN
                   TopHilight(Y,H,TRUE);
                    END;
                   END;
    | ArrU      : MenuHilight(X,RealY,H,FALSE);
                  IF X>0 THEN
                   IF NOT((X-1) IN Flags[Level]) THEN
                    DEC(X,1);
                   ELSE
                    DEC(X,2);
                    END;
                   ELSIF X=0 THEN
                    X:=RealAantV;
                    END;
                    MenuHilight(X,RealY,H,TRUE);
    | ArrD      : MenuHilight(X,RealY,H,FALSE);
                  IF X<RealAantV THEN
                   IF NOT((X+1) IN Flags[Level]) THEN
                    INC(X,1);
                   ELSE
                    INC(X,2);
                    END;
                   ELSIF X=RealAantV THEN
                    X:=0;
                    END;
                  MenuHilight(X,RealY,H,TRUE);


   END; (* CASE *)
   DoSelect;
   WakeUp(H);
  END; (*LOOP *)
 END; (*With *)
 (* Return value, MAX(CARDINAL) is escape, *)
 Use(FullScreen);
 RETURN Terug;
END GetPullKey;

PROCEDURE SubKey(H:PullHandle;X,Y:CARDINAL):CARDINAL;
(* The submenu main routine *)

VAR A : CARDINAL;

BEGIN
 ShowMouse;
 Dat[H]^.Level:=1;     Dat[H]^.WinOpen:=Set9(0);
 A:=SubMenu(X,Y,H,1);
 HideMouse;
 RETURN A;
END SubKey;

VAR D : CARDINAL;

BEGIN
 Active:=BitSet(0);
 D:=MouseInstalled();
 SoftwareTextMouse(MAX(CARDINAL),256*128);
END PullDown.