IMPLEMENTATION MODULE PullDown;

FROM Window   IMPORT WinDef,Use,GotoXY,TextColor,DirectWrite,WinType,Color,
                     CursorOff,FullScreen,CursorOn,TextBackground;
FROM Str      IMPORT ItemS,Delete,Length,CharPos,Slice,RCharPos;
FROM IO       IMPORT WrStr,WrCharRep,WrCard;
FROM Mouse    IMPORT ShowMouse,HideMouse,GetMouseAction,Button,SoftwareTextMouse,MouseInstalled;
FROM Lib      IMPORT ScanR,AddAddr,FatalError;
FROM Storage  IMPORT ALLOCATE,DEALLOCATE;
FROM IO       IMPORT KeyPressed,RdKey;

IMPORT Window;

CONST   Min    = 40;    (* Added to uuencode a number into a string
                           Must be >40, because ' is the separator *)
        Divver = 256-Min;  (* Space left per byte. *)
        DvD    = Divver*(Divver-1); (* Reserve upper "Min" values for
                                        callsigns Submenus *)
        ScrX   = 80;       (* Width of Screen. Fixed for TopSpeed,
                               since TopSpeed's Window is limited to 80 *)


        (* Some key-codes, as returned by GetKey*)

        ESC    =    1BH;                    ArrU   = 04800H;
        ArrL   = 04B00H;                    ArrR   = 04D00H;
        ArrD   = 05000H;                    CR     =     13;
        F1     = 3B00H;

(*

Procedure ELib, only XtdLib dependance PullDown.

Commented, because a procedure like GetKey doesn't belong to this highlevel
module. Included for porting purposes.

In future a modified routine like this will return, because I need to add
mouse support to it.*)

PROCEDURE GetMouseOrKey():CARDINAL;

VAR GA : CARDINAL;
    Da : Button;
    X,Y : CARDINAL;

BEGIN
 ShowMouse;
 LOOP
  IF KeyPressed() THEN
   GA:=ORD(RdKey());
   EXIT
   END;
  GetMouseAction( Da, X, Y );
  Y:=Y>>3; X:=X>>3;
  Use(FullScreen);
  GotoXY(60,12);
  WrCard(X,5);WrCard(Y,5);
  END;
  IF GA=0 THEN
   GA:=ORD(RdKey())<<8;
   END;
 HideMouse;
 RETURN GA;
END GetMouseOrKey;

(* Inline procedure, stops blinking of text, assembler. *)
(*Function ax=1003H  bl=0 int 10H, NOT ESSENTIAL, YOU CAN DELETE IT OR
USE YOUR OWN EQUIVALENT! If you delete it don't use colors
 Window.Color(8)..Window.Color(15). These will blink *)

CONST       (*%T _fcall *)    Ret = 0CBH; (*%E *)
            (*%F _fcall *)    Ret = 0C3H; (*%E *)

TYPE A12 = ARRAY[0..11] OF BYTE;

INLINE PROCEDURE BlinkOff=A12(50H,53H,0B8H,03H,10H,32H,0DBH,0CDH,10H,5BH,58H,Ret);
(*Inline off *)

TYPE   Set9           = SET OF [0..8];
       BitSet         = SET OF [0..NrO];
       BitSet50       = SET OF [0..50];
       PositionsType  = ARRAY[0..NrO] OF CARDINAL; (* Used to predefine
                                                      top-items, when automatic
                                                      calculation fails. Only
                                                      internal in this
                                                      version *)

       MouseRec       =  RECORD
                          X1,Y1,X2,Y2  :CARDINAL;
                          END;


         DataType=
           RECORD
            Top        : StType;              (* direct pointer to Topstring*)
            TopNr      : CARDINAL;            (* nr of items in top*)
            Posi       : PositionsType;       (* The calculated or predefined
                                                  x positions of the topitems*)
            Mouse      : ARRAY[0..10] OF MouseRec;
                                              (* Areas which are mouse-clickable*)
            MaxW,                             (* widest word in each
                                                        menustring *)
            Size0,                            (* length topitems per menustring
                                                 Only Top menustring is parsed*)
            DefW,                             (* calculated X-positions
                                                 Top items*)
            AantV                             (* items per menustring *)
                    : ARRAY[1..NrO] OF CARDINAL;
            Flags   : BitSet50;               (* Used to process separators *)

            WinHan  : ARRAY[0..8] OF WinType; (* Window Handles, 0 is Top,
                                                 1 is normal menu, 2 is 1st
                                                 submenu, 3 is 2nd submenu etc,
                                                 till maximal "Level" *)
            WinOpen    : Set9      ;          (* Which handles of WinHan are
                                                  used now? *)

            MenuNr  : CARDINAL;               (* Nr of menustrings*)
            Menu    : ARRAY[1..NrO] OF StType;(* Pointers to each menustring*)
            MenSiz  : CARDINAL;               (* Menu.PullSize, see def
                                                  PullObject*)
            Level   : CARDINAL;               (* Recursion level.
                                                Top=0,Pull=1 Sub=2..22 *)
            Pull    : PullDef;                (* PullDef is defined and
                                                  commented in the DEF file*)
            Sub   : BOOLEAN;
            END;

     PObjPoint     = POINTER TO DataType; (* Pointertype to record*)

VAR  Dat     : ARRAY[0..19] OF PObjPoint; (* several objects at once,
                                             PullHandle is index in this
                                             array *)
     Active  : BitSet;                    (* Which pointer in Dat are
                                              allocated?*)

PROCEDURE ClrScrF();
(* Clear Fullscreen, Window.Use current handle*)

VAR TempW:Window.WinType;

BEGIN
 TempW:=Window.Used();
 Use(Window.FullScreen);
 Window.Clear;
 Use(TempW);
END ClrScrF;

PROCEDURE WakeUp(H:PullHandle);
(* Unhide all PullDown windows of handle(H) *)

VAR A : CARDINAL;

BEGIN
 WITH Dat[H]^ DO
 FOR A:= 0 TO Level DO
  IF A IN WinOpen THEN
   Window.PutOnTop(WinHan[A]);
   END;
  END;
 END;
END WakeUp;

PROCEDURE MakeObjIndex(Obj:ADDRESS;D:PObjPoint;Siz:CARDINAL);
(* Calculates/fills Menu and MenuNr records from raw menu data*)

VAR A,P : CARDINAL;

BEGIN
 IF Siz>6 THEN
  DEC(Siz,6);
  D^.MenuNr:=1;
  D^.Menu[1]:=Obj;
  P:=0;
  LOOP
   IF P> (Siz) THEN
    EXIT
    END;
   A:=ScanR(AddAddr(Obj,P),Siz-P+8,0);
   IF D^.MenuNr>NrO THEN
    EXIT
    END;
   IF A < (Siz-P) THEN
    INC(P,A+1);
    INC(D^.MenuNr);
    D^.Menu[D^.MenuNr]:=AddAddr(Obj,P);
   ELSE
    EXIT
    END;
  END;
  INC(D^.MenuNr);
  END;
END MakeObjIndex;

PROCEDURE OnOffItem(H:PullHandle;Label:CARDINAL);
(* Toggle the On/Off option on or off *)

VAR St : StType;
    S  : ARRAY[0..100] OF CHAR;
    A : CARDINAL;

BEGIN
 St:=GetObjAddr(H,Label,A);
 Slice (S,St^,0,A);
 (* TopSpeed 1.17 users, if you don't wanna make your own RCharPos, then
     hardcode something like Length(S)-3 in here, and delete the first
     two IF and RCharPos statements*)
 A:=RCharPos(S,"O");
 IF (A = MAX(CARDINAL)) OR ((Length(S)-A)>5) THEN
  A:=RCharPos(S,"o");
  END;
 IF (A = MAX(CARDINAL)) OR ((Length(S)-A)>5) THEN
  RETURN;
  END;
 IF (CAP(S[A+1])="N") AND (S[A+2]=" ") THEN
  St^[A+1]:="f";   St^[A+2]:="f";
  END;
 IF (CAP(S[A+1])="F") AND (CAP(S[A+2])="F") THEN
  St^[A+1]:="n";   St^[A+2]:=" ";
  END;
END OnOffItem;

PROCEDURE GetObjAddr(H:PullHandle;Label:CARDINAL;VAR Siz:CARDINAL):StType;

VAR A,P,P2 : CARDINAL;
    D,St   : StType;

BEGIN
 Siz:=0;
 IF Dat[H]^.MenSiz>6 THEN
  D:=Dat[H]^.Menu[1];
  P:=0;
  LOOP
   IF (P+6)> (Dat[H]^.MenSiz) THEN
    RETURN NIL;
    END;
   A:=ScanR(AddAddr(D,P),Dat[H]^.MenSiz-P+6,"'");
   IF A < (Dat[H]^.MenSiz-P) THEN
    St:=AddAddr(D,P);
    P2:=(ORD(St^[A+1])-Min)*Divver+ORD(St^[A+2])-Min;
    IF P2=Label THEN
     Siz:=CharPos(St^,"'");
     RETURN St;
     END;
    INC(P,A+3);
   ELSE
    RETURN NIL;
    END;
  END;
  END;
END GetObjAddr;

PROCEDURE GetObjItem(VAR S2:ARRAY OF CHAR;Y:CARDINAL;VAR S : ARRAY OF CHAR);
(* S2 not changed, VAR for size/speedup reasons *)
(* Get Y'nd item from S2, return in S with constant chars deleted*)

VAR A:CARDINAL;

BEGIN
 ItemS(S,S2,"'",Y);
 IF Y # 0 THEN
  Delete(S,0,2);
  END;
END GetObjItem;

PROCEDURE GetObjCode(VAR S2:ARRAY OF CHAR;Y:CARDINAL;VAR Code:CARDINAL);
(* S2 not changed, VAR for size/speedup reasons *)
(* Get Y'nd item from S2, calculate constant from constant chars,
   return constant in Code *)
VAR S : ARRAY[0..20] OF CHAR;

BEGIN
 ItemS(S,S2,"'",Y);
 Code:=Divver*(ORD(S[0])-Min)+ ORD(S[1])-Min;
END GetObjCode;

PROCEDURE Hilight(X,Y,Len:CARDINAL;FCol,BCol:Color;VAR St:ARRAY OF CHAR);
(* St not changed, VAR for size/speedup reasons *)
(* Write String St in color FCol and BCol to screenpositions (X,Y) (relative)
    and pad to length Len.*)

VAR A: CARDINAL;

BEGIN
 IF (X=0) AND (Y>0) THEN X:=1; END;
 TextColor(FCol);
 TextBackground(BCol);
 GotoXY(X,Y);
 WrStr(St);
 IF (Length(St)-1)<Len THEN
  WrCharRep(" ",Len-Length(St)+1);
  END;
END Hilight;

PROCEDURE MenuHilight(X,Nr:CARDINAL;H:PullHandle;HiLight:BOOLEAN);
(* Hilight for normal menus. Get some data from PObjPoint first. *)

VAR S: ARRAY[0..40] OF CHAR;
    FCol,BCol : Color;

BEGIN
 WITH Dat[H]^ DO
  IF HiLight THEN
   FCol:=Pull.Cols.HiCol;BCol:=Pull.Cols.HiBack
  ELSE
   FCol:=Pull.Cols.Text;BCol:=Pull.Cols.InCol
   END;
  Use(WinHan[Level]);
  GetObjItem(Menu[Nr]^,X,S);
  Hilight(2,X+2,MaxW[Nr]-1,FCol,BCol,S);
 END;
END MenuHilight;

PROCEDURE TopHilight(Y:CARDINAL;H:PullHandle;Hil:BOOLEAN);
(* Hilight for Topmenu, get all data from Top records*)

VAR S: ARRAY[0..40] OF CHAR;
  VAR FCol,BCol:Color;

BEGIN
 WITH Dat[H]^ DO
  IF Hil THEN
   FCol:=Pull.Cols.HiTop;BCol:=Pull.Cols.HiBTop;
  ELSE
   FCol:=Pull.Cols.TextTop;BCol:=Pull.Cols.Top;
   END;
  Use(WinHan[0]);
  ItemS(S,Top^,"'",Y); (* No codes-constants in TopMenu, direct ItemS*)
  Hilight(Posi[Y]+1,0,Size0[Y]-1,FCol,BCol,S);
  END;
END TopHilight;

PROCEDURE WritePullD(VAR St:ARRAY OF CHAR;OpenWin:BOOLEAN;Y,NoVeld,Positie,MaxVeld:CARDINAL;
                                         Cols:ColT;VAR SWin:WinType;VAR Flags:BitSet50);

(* Put Menu St on screen with all details except hilighting,
   Used to write ALL menus, both from PullDown (procedure GetPullKey)
   and SubMenu (procedure SubMenu). *)

VAR Tel1        : CARDINAL;
    DStr        : ARRAY[0..79] OF CHAR;
    WD2         : WinDef;

BEGIN
 (* Avoid menu disappearing from screen on left or right side. Leftover
     from old pulldown, don't know if it's needed, but it is safer to
     keep it. *)
 WITH Cols DO
 IF OpenWin THEN
  IF Positie+MaxVeld+1>(ScrX-1) THEN Positie:=(ScrX-1)-MaxVeld; END;
  IF Positie=0 THEN Positie:=1; END;
  (* Open a Window *)
  WD2.X1:=Positie-1;
  WD2.Y1:=Y;
  WD2.X2:=Positie+MaxVeld;
  WD2.Y2:=Y+NoVeld;
  WD2.Foreground:=Rand;
  WD2.Background:=InCol;
  WD2.FrameOn   :=FALSE;
  WD2.Hidden    :=FALSE;
  SWin:=Window.Open(WD2);
  Use(SWin);
 ELSE
  TextColor(Rand);
  TextBackground(InCol);
  END;
 FOR Tel1:=0 TO NoVeld-2 DO
  ItemS(DStr,St,"'",Tel1);
  IF (Tel1#0) THEN
   Delete(DStr,0,2);
   END;

  IF DStr[0] # CHR(0)THEN
                           (* First character "|" ? Then make a Ĵ *)
   IF DStr[0]="|" THEN
    INCL(Flags,Tel1);
    GotoXY(1,Tel1+2);
    WrStr(Style[2]);
    IF MaxVeld>1 THEN
     WrCharRep(Style[3],MaxVeld);
     END;
    WrStr(Style[1]);
   ELSE                         (* else put the string to screen*)
    EXCL(Flags,Tel1);
    TextColor(Rand);
    GotoXY(1,Tel1+2);
    WrStr(Style[4]);
    TextColor(Text);
    WrStr(DStr);
    TextColor(Rand);
    GotoXY(MaxVeld+2,Tel1+2);
    WrStr(Style[4]);
    END;
   END;
  END;
  (* Draw  and Ŀ . Partially with DirectWrite because I had problems with
   wrapping in Ts 1.17. *)
 GotoXY(1,NoVeld+1); WrStr(Style[5]); WrCharRep(Style[3],MaxVeld);
 DirectWrite(MaxVeld+2,NoVeld+1,ADR(Style[7]),1); (* To avoid wrap problems*)
 GotoXY(1,1); WrStr(Style[6]); WrCharRep(Style[3],MaxVeld); WrStr(Style[0]);
 END;
END WritePullD;

PROCEDURE PullOpen(Menu : PullObject;InDef:PullDef):PullHandle;
(* Opens any PullDown object, either PullDown menu or SubMenu. *)

VAR
     A,B,Max             : CARDINAL;
     H                   : PullHandle;
     Flag                : BOOLEAN;
     DumStr              : ARRAY[0..79] OF CHAR;

CONST WTop=WinDef(0,0,ScrX-1,0,White,Black,FALSE,FALSE,TRUE,FALSE,"",Black,Black);

BEGIN
 (* Search next free "Handle"*)
 A:=0;
 LOOP
  IF NOT (A IN Active) THEN
   EXIT
   END;
  IF A=19 THEN
   ClrScrF;
   Window.Use(FullScreen);
   FatalError(" Too many open Pulldownmenus");
   EXIT
   END;
  INC(A);
  END;
 H:=PullHandle(A);
 INCL(Active,H);

 ALLOCATE(Dat[H],SIZE(DataType));
 Dat[H]^.WinOpen:=Set9(0);

 (* Sub or PullDownmenu? *)

 Dat[H]^.Sub:=FALSE;
 IF Menu.MenuAddr=NIL THEN
  Dat[H]^.Sub:=TRUE;
  END;

 Dat[H]^.Pull:=InDef;
 Dat[H]^.Top:=Menu.MenuAddr;
 MakeObjIndex(Menu.PullAddr,Dat[H],Menu.PullSize);
 Dat[H]^.MenSiz:=Menu.PullSize;

 CursorOff; BlinkOff;

 IF NOT Dat[H]^.Sub THEN
 (* Open Topmenu Window for pulldowns only. *)

  WITH Dat[H]^ DO
   WinHan[0]:=Window.Open(WTop);
   Mouse[0].X1:=0;
   Mouse[0].Y1:=0;
   Mouse[0].Y2:=0;
   Mouse[0].X2:=ScrX-1;
   INCL(WinOpen,0);
   END;
  TextColor(InDef.Cols.TextTop);
  TextBackground(InDef.Cols.Top);
  END;

  (* Count # of items & minimal width window, both per menu*)
  WITH Dat[H]^ DO
  Use(FullScreen);
  TextColor(White);
  GotoXY(1,1);
   FOR A:=1 TO MenuNr-1 DO
    MaxW[A]:=0;
    AantV[A]:=0;
    DefW[A]:=0;
    LOOP
     GetObjItem(Menu[A]^,AantV[A],DumStr);
     IF DumStr[0]=CHR(0) THEN
      INC(AantV[A]);
      EXIT
      END;
     IF (Length(DumStr)>MaxW[A])    THEN
      MaxW[A]:=Length(DumStr);
      END;
     INC(AantV[A]);
     END;
    END;
   IF NOT Dat[H]^.Sub THEN
   TopNr:=1; (* Count and calculate width Top items*)
   LOOP
    ItemS(DumStr,Top^,"'",TopNr);
    IF DumStr[0] = CHR(0) THEN
     EXIT
     END;
    Size0[TopNr]:=Length(DumStr);
    INC(TopNr);
    END;

  A:=0;
  FOR B:= 1 TO Dat[H]^.TopNr-1 DO     (* Total width top items *)
   INC(A,Dat[H]^.Size0[B]);
   END;

 (* Calculate space between top items, with PosiParam as argument *)
  Max:=(ScrX - A - Dat[H]^.Pull.PosiParam) DIV (Dat[H]^.TopNr-2);

  A:=0;
  FOR B:= 1 TO Dat[H]^.TopNr DO (* convert into x-coordinates*)
   Dat[H]^.Posi[B]:=A;
   INC(A,Dat[H]^.Size0[B]+Max);
   END;
 END; (* IF Sub *)
END; (*Width*)

RETURN H;
END PullOpen;

PROCEDURE PullClose(H:PullHandle);
(* Close all Window-handles and release memory*)

VAR A :CARDINAL;

BEGIN
 CursorOn;
 Use(FullScreen);
 FOR A:= 0 TO Dat[H]^.Level DO
  IF A IN Dat[H]^.WinOpen THEN
   Window.Close(Dat[H]^.WinHan[A]);
   END;
  END;
 DEALLOCATE(Dat[H],SIZE(DataType));
 EXCL(Active,H);
END PullClose;

PROCEDURE PullHide(H:PullHandle);
(* Hide a PullDown menu temporarily *)

VAR A :CARDINAL;

BEGIN
 IF H IN Active THEN
  CursorOn;
  Use(FullScreen);
  FOR A:= 0 TO Dat[H]^.Level DO
   IF A IN Dat[H]^.WinOpen THEN
    Window.Hide(Dat[H]^.WinHan[A]);
    END;
   END;
  END;
END PullHide;

PROCEDURE SetPositions(H:PullHandle;NewX:ARRAY OF BYTE);

VAR A : CARDINAL;

BEGIN
 FOR A :=0 TO HIGH(NewX) DO
  Dat[H]^.Posi[A+1]:=CARDINAL(NewX[A]);
  END;
END SetPositions;

PROCEDURE SubMenu(XIn,YIn:CARDINAL;H:PullHandle;Nr:CARDINAL):CARDINAL;
(* The procedure which handles navigating in a submenu, recursively *)

VAR Tek                 : CARDINAL;
    Terug               : CARDINAL;
    Xi                  : CARDINAL;
    A,B                 : CARDINAL;
    OwnFl               : BitSet50;

PROCEDURE DoSubSelect;                     (* interface to Select procedure*)
BEGIN
 WITH Dat[H]^ DO
 IF Pull.SelectProc # NULLPROC THEN
  GetObjCode(Menu[Nr]^,Xi+1,A);
  A:=Pull.SelectProc(A,H)
  END;
  END;
END DoSubSelect;

BEGIN
 Xi:=0;
 WITH Dat[H]^ DO
  INC(Level);
  WritePullD(Menu[Nr]^,TRUE,YIn,AantV[Nr],XIn,MaxW[Nr],Pull.Cols,WinHan[Level],OwnFl);
  INCL(WinOpen,Level);
  MenuHilight(Xi,Nr,H,TRUE);
  END;
 Use(FullScreen);
 DoSubSelect;
  WITH Dat[H]^ DO
   LOOP
    Tek:=GetMouseOrKey();
    CASE Tek OF
     | F1        : IF Pull.HelpProc # NULLPROC THEN
                    GetObjCode(Menu[Nr]^,Xi+1,A);
                    A:=Pull.HelpProc(A,H)
                    END;
     | ESC       : Terug:=MAX(CARDINAL);
                   EXIT;
     | CR        : GetObjCode(Menu[Nr]^,Xi+1,A);
                   IF A>DvD THEN
                    Terug:=SubMenu(XIn+5,YIn+1,H,A-DvD);
                   ELSE
                    Window.Use(Window.FullScreen);
                    Terug:=Pull.ResultProc(A,H);
                    IF Terug=1 THEN
                     (*Window.Close(WinHan[Level]); *)
                     Use(WinHan[Level]);
                     WritePullD(Menu[Nr]^,FALSE,YIn,AantV[Nr],XIn,MaxW[Nr],Pull.Cols,WinHan[Level],OwnFl);
                     MenuHilight(Xi,Nr,H,TRUE);
                     END;
                    WakeUp(H);
                    END;
     | ArrU      : IF Xi>0 THEN
                    MenuHilight(Xi,Nr,H,FALSE);
                    IF NOT((Xi-1) IN OwnFl) THEN
                     DEC(Xi,1);
                    ELSE
                     DEC(Xi,2);
                     END;
                   MenuHilight(Xi,Nr,H,TRUE);
                   END;
    | ArrD      : IF Xi<(AantV[Nr]-2) THEN
                    MenuHilight(Xi,Nr,H,FALSE);
                   IF NOT((Xi+1) IN OwnFl) THEN
                    INC(Xi,1);
                   ELSE
                    INC(Xi,2);
                    END;
                   MenuHilight(Xi,Nr,H,TRUE);
                   END;
   END; (* CASE *)
   DoSubSelect;

  END; (*LOOP *)

 Window.Close(WinHan[Level]);
 EXCL(WinOpen,Level);
 DEC(Level);
(* IF  NOT ((Level = 1) AND Sub) THEN
  Use(WinHan[Level]);
  END; *)
 END; (*With *)

(* Use(FullScreen); *)
 (* Geef de waarde terug, 65535 is escape, *)
 RETURN Terug;
END SubMenu;

PROCEDURE GetPullKey(H:PullHandle;StartTopNr:CARDINAL):CARDINAL;

VAR RealY,RealAantV     : CARDINAL;
    Temp                : CARDINAL;
    Tek                 : CARDINAL;
    Terug               : CARDINAL;
    DumStr              : ARRAY[0..100] OF CHAR;
    X                   : CARDINAL;
    Y                   : CARDINAL;
    DummyBitSet         : BitSet50;

PROCEDURE DoSelect;
BEGIN
 WITH Dat[H]^ DO
   GetObjCode(Menu[RealY]^,X+1,Temp);
   IF Pull.SelectProc # NULLPROC THEN
    Terug:=Pull.SelectProc(Temp,H)
    END;
   END;
END DoSelect;

PROCEDURE DoRealY;
(* RealY is index menudata of Y-Coord Y *)

BEGIN
  WITH Dat[H]^ DO
   RealY:=ORD(Top^[Y])-Min;
   RealAantV:=(AantV[RealY]-2);
   END;
END DoRealY;

PROCEDURE WritePD(H:PullHandle;OpenWin:BOOLEAN);
(* Interface layer between GetPullKey/SubMenu and WritePullD *)

VAR A  : CARDINAL;

BEGIN
 WITH Dat[H]^ DO
   A:=ORD(Top^[Y])-Min; (* similar to RealY calculation in GetPullKey*)
   IF OpenWin THEN
    INCL(WinOpen,1);
   ELSE
    Use(WinHan[1]);
    END;
   WritePullD(Menu[A]^,OpenWin,1,AantV[A],Posi[Y],MaxW[A],Pull.Cols,WinHan[1],Flags);
 END;
END WritePD;

BEGIN
 IF NOT (H IN Active) THEN
  FatalError(" Invalid PullHandle ");
  END;
 
 Window.PutOnTop(Dat[H]^.WinHan[0]);
 Window.Use(Dat[H]^.WinHan[0]);

GotoXY(1,1);
WrCharRep(" ",ScrX);
FOR Temp:=1 TO Dat[H]^.TopNr-1 DO
 ItemS(DumStr,Dat[H]^.Top^,"'",Temp);
 GotoXY(Dat[H]^.Posi[Temp]+1,0);
 WrStr(DumStr);
 END;

WITH Dat[H]^ DO
 Y:=1;
 IF StartTopNr<TopNr THEN
  Y:=StartTopNr;
  END;
 Level:=1;
 X:=DefW[Y];
 DoRealY;
 WritePD(H,TRUE);
 INCL(WinOpen,Level);
 MenuHilight(X,RealY,H,TRUE);
 IF Dat[H]^.Pull.HiBar=TRUE THEN
   TopHilight(Y,H,TRUE);
  END;
 END;
 Use(FullScreen);
 DoSelect;
 WITH Dat[H]^ DO
  LOOP
   Tek:=GetMouseOrKey();
   DoRealY;
    CASE Tek OF
     | F1        : GetObjCode(Menu[RealY]^,X+1,Temp);
                   IF Pull.HelpProc # NULLPROC THEN
                     Terug:=Pull.HelpProc(Temp,H)
                    END;
     | ESC       : Terug:=MAX(CARDINAL);
                   EXIT;
     | CR        : GetObjCode(Menu[RealY]^,X+1,Temp);
                   IF Temp>DvD THEN
                    Terug:=SubMenu(Posi[Y]+5,X+2,H,Temp-DvD);
                   ELSE
                    Window.Use(Window.FullScreen);
                    Terug:=Pull.ResultProc(Temp,H);
                    IF Terug=1 THEN
                     WritePD(H,FALSE);
                     MenuHilight(X,RealY,H,TRUE);
                     END;
                    WakeUp(H);
                    END;
                    (* PullClose*)
     | ArrL      : IF Y>1 THEN
                   TopHilight(Y,H,FALSE);
                   DefW[Y]:=X;
                   DEC(Y);
                   X:=DefW[Y];
                   DoRealY;
                   Window.Close(WinHan[1]);
                   EXCL(WinOpen,1);
                   WritePD(H,TRUE);
                   MenuHilight(X,RealY,H,TRUE);
                   IF Pull.HiBar=TRUE THEN
                    TopHilight(Y,H,TRUE);
                    END;
                   END;
    | ArrR      : IF Y<(Dat[H]^.TopNr-1) THEN
                   TopHilight(Y,H,FALSE);
                   DefW[Y]:=X;
                   INC(Y);
                   X:=DefW[Y];
                   DoRealY;
                   Window.Close(WinHan[1]);
                   EXCL(WinOpen,1);
                   WritePD(H,TRUE);
                   MenuHilight(X,RealY,H,TRUE);
                   IF Pull.HiBar=TRUE THEN
                   TopHilight(Y,H,TRUE);
                    END;
                   END;
    | ArrU      : MenuHilight(X,RealY,H,FALSE);
                  IF X>0 THEN
                   IF NOT((X-1) IN Flags) THEN
                    DEC(X,1);
                   ELSE
                    DEC(X,2);
                    END;
                   ELSIF X=0 THEN
                    X:=RealAantV;
                    END;
                    MenuHilight(X,RealY,H,TRUE);
    | ArrD      : MenuHilight(X,RealY,H,FALSE);
                  IF X<RealAantV THEN
                   IF NOT((X+1) IN Flags) THEN
                    INC(X,1);
                   ELSE
                    INC(X,2);
                    END;
                   ELSIF X=RealAantV THEN
                    X:=0;
                    END;
                  MenuHilight(X,RealY,H,TRUE);


   END; (* CASE *)
   DoSelect;
   WakeUp(H);
  END; (*LOOP *)
 END; (*With *)
 (* Return value, MAX(CARDINAL) is escape, *)
 Use(FullScreen);
 HideMouse;
 RETURN Terug;
END GetPullKey;

PROCEDURE SubKey(H:PullHandle;X,Y:CARDINAL):CARDINAL;
(* The submenu main routine *)

BEGIN
 ShowMouse;
 Dat[H]^.Level:=1;
 Dat[H]^.WinOpen:=Set9(0);
 HideMouse;
 RETURN SubMenu(X,Y,H,1);
END SubKey;

VAR D : CARDINAL;

BEGIN
 Active:=BitSet(0);
 D:=MouseInstalled();
 SoftwareTextMouse(0,7);
END PullDown.