MODULE SubDemo;
(* Submenu demo, XtdLib package, (C) by Marco van de Voort 1997

Written because PullDemo didn't show the submenus to clearly.

MENU.SRC belongs (also) to this demo! Menu.DEF not necessarily, since it
can be generated out of MENU.SRC! .SRC files reside in directory source.
Please note that Menu.SRC has changed since the last version, please
recompile!

This module looks huge, but so is the menu. You can delete at least half of
it by not using the select and helpfunctions. Simply replace the two last
procedurenames in the PullDef definitions with NULLPROC *)

FROM Window IMPORT WinType,Color;
FROM Menu     IMPORT FirstSub_Dat,FirstSub;
FROM PullDown IMPORT PullOpen,PullHandle,GetPullKey,PullClose,PullDef,ColT,Style3,
                     PositionsType,PullObject,SubKey;
FROM Lib IMPORT EnableBreakCheck;
FROM ELib IMPORT GetKey,StrStr;
FROM Str IMPORT Length;

IMPORT IO,Menu,Window,PullDown;

TYPE    StrArr  = ARRAY[0..400] OF CHAR;
        StrPoint= POINTER TO StrArr;

CONST WrLn=CHR(13)+CHR(10);
      SubMenuSubMenu= WrLn+ "You pressed help on a submenu.  " +WrLn+
                   "Press escape to make this window disappear," +WrLn+
                   "then press enter to open the submenu.";

PROCEDURE WrSubLab(S:ARRAY OF CHAR);
(* Rough procedure, writes the S on a certain spot to the screen*)

BEGIN
 Window.Use (Window.FullScreen);
 Window.GotoXY(40,20);
 IO.WrCharRep(" ",40);
 Window.GotoXY(40,20);
 Window.TextColor(Magenta);
 IO.WrStr("Last picked label : ");
 Window.TextColor(Green);
 IO.WrStr(S);
END WrSubLab;

PROCEDURE WrSubSelect(S:ARRAY OF CHAR);
(* Writes the select text S to the screen, for submenus*)

BEGIN
 Window.CursorOff;
 Window.GotoXY(10,23);
 Window.TextColor(Window.Blue);
 IO.WrCharRep("",50);
 Window.GotoXY(10,23);
 Window.TextColor(Red);
 IO.WrStr("SubMenu:");
 Window.TextColor(Yellow);
 IO.WrStr(S);
END WrSubSelect;

CONST SubMenuDef=Window.WinDef(20,4,65,8,White,Black,FALSE,TRUE,FALSE,TRUE,
                            Window.DoubleFrame,Yellow,Black);

PROCEDURE WrHelp(S:ARRAY OF CHAR);

VAR L : WinType;
    A : CARDINAL;

BEGIN
 L:=Window.Open(SubMenuDef);
 Window.Use (L);
 IO.WrLn;
 IO.WrStr("This is the help for : ");
 IO.WrStr(S);
 A:=GetKey();
 Window.Close(L);
END WrHelp;

PROCEDURE SubMenu(InCode,H:CARDINAL):CARDINAL;

VAR A : CARDINAL;

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu.Beer             :      WrSubLab("Beer");
   | Menu.VinRose          :      WrSubLab("VinRose");
   | Menu.R_Bordeaux       :      WrSubLab("R_Bordeaux");
   | Menu.CotesRhone       :      WrSubLab("CotesRhone");
   | Menu.VinDPRed         :      WrSubLab("VinDPRed");
   | Menu.W_Bordeaux       :      WrSubLab("W_Bordeaux");
   | Menu.Moezel2          :      WrSubLab("Moezel2");
   | Menu.VinDPWhite       :      WrSubLab("VinDPWhite");
   | Menu.Champi           :      WrSubLab("Champi");
   | Menu.Zekt2            :      WrSubLab("Zekt2");
   | Menu.Whisky           :      WrSubLab("Whisky");
   | Menu.JongeK           :      WrSubLab("JongeK");
   | Menu.Vodka            :      WrSubLab("Vodka");
   | Menu.Aper1            :      WrSubLab("Aper1");
   | Menu.Aper2            :      WrSubLab("Aper2");
   | Menu.Aper3            :      WrSubLab("Aper3");

   END;
RETURN 0 ;
END SubMenu;

PROCEDURE SubMenuSelect(InCode,H:CARDINAL):CARDINAL;

BEGIN
 Window.Use(Window.FullScreen);
    CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu.Beer             :      WrSubSelect("Beer");
   | Menu.VinRose          :      WrSubSelect("VinRose");
   | Menu.R_Bordeaux       :      WrSubSelect("R_Bordeaux");
   | Menu.CotesRhone       :      WrSubSelect("CotesRhone");
   | Menu.VinDPRed         :      WrSubSelect("VinDPRed");
   | Menu.W_Bordeaux       :      WrSubSelect("W_Bordeaux");
   | Menu.Moezel2          :      WrSubSelect("Moezel2");
   | Menu.VinDPWhite       :      WrSubSelect("VinDPWhite");
   | Menu.Champi           :      WrSubSelect("Champi");
   | Menu.Zekt2            :      WrSubSelect("Zekt2");
   | Menu.Whisky           :      WrSubSelect("Whisky");
   | Menu.JongeK           :      WrSubSelect("JongeK");
   | Menu.Vodka            :      WrSubSelect("Vodka");
   | Menu.Aper1            :      WrSubSelect("Aper1");
   | Menu.Aper2            :      WrSubSelect("Aper2");
   | Menu.Aper3            :      WrSubSelect("Aper3");
   END;
RETURN 0 ;
END SubMenuSelect;

PROCEDURE SubMenuHelp(InCode,H:CARDINAL):CARDINAL;

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu.Beer             :      WrHelp("Beer");
   | Menu.VinRose          :      WrHelp("VinRose");
   | Menu.R_Bordeaux       :      WrHelp("R_Bordeaux");
   | Menu.CotesRhone       :      WrHelp("CotesRhone");
   | Menu.VinDPRed         :      WrHelp("VinDPRed");
   | Menu.W_Bordeaux       :      WrHelp("W_Bordeaux");
   | Menu.Moezel2          :      WrHelp("Moezel2");
   | Menu.VinDPWhite       :      WrHelp("VinDPWhite");
   | Menu.Champi           :      WrHelp("Champi");
   | Menu.Zekt2            :      WrHelp("Zekt2");
   | Menu.Whisky           :      WrHelp("Whisky");
   | Menu.JongeK           :      WrHelp("JongeK");
   | Menu.Vodka            :      WrHelp("Vodka");
   | Menu.Aper1            :      WrHelp("Aper1");
   | Menu.Aper2            :      WrHelp("Aper2");
   | Menu.Aper3            :      WrHelp("Aper3");
   END;
RETURN 0 ;
END SubMenuHelp;

 (* The colorscheme in below definition is horrible, but all colors are
               different, so you can easily see what is what *)
CONST SubDef=PullDef(ColT(Yellow,LightCyan,LightGreen,Blue,Yellow,Magenta,Magenta,LightBlue,DarkGray,Style3)
                   ,FALSE,TRUE,PositionsType(22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                        0,0,0,0,0,0,0,0,0,0),SubMenu,SubMenuHelp,SubMenuSelect);

VAR
    H   : PullHandle;
    I   : CARDINAL;
    S   : ARRAY[0..79] OF CHAR;

BEGIN
 (* PullOpen is used, but FirstSub is a SubMenu object, see Menu.DEF!
    In the definition of FirstSub, some of the fields are NIL to indicate
     a SubMenu. *)
 H:=PullOpen(PullObject(FirstSub),SubDef); (* textual, colors and procedure
                                              data transfer to PullDown,
                                               sets up handle*)
 I:=SubKey(H,2,13);                        (* SubMenu on coordinates (2,13)*)
 PullClose(H);                             (* Close SubMenu, release memory.*)
END SubDemo.