MODULE GE;
(* Standalone util, also demo Pulldown module,
    XtdLib package, (C) by Marco van de Voort 1996

The dependance on ELib and CoreCrt is minimal, if you have a interruptlisting
at hand (SetCurSize, Scroll* and BlinkOff procedures) elimination of XtdLib is
possible, since M2 versions of StrStr and GetKey exist in the ModAsm library.

I really hate menu programs, but I also hate typing the same change
  directory, start program, restore old directory sequence over and
  over again. Maintaining batchfiles is not my strongest point either.
  At a certain point, I merged several startup batchfiles into one,
  and used 4Dos commands to make it more userfriendly. Because the batchfile
  was very simple and structured (a menu when no parameters are displayed,
  a bunch of if... gotos and a small piece of code for every entry) I
  made a simple batchfile creator, which compiled a textfile (G.NFO, since
  TXT DOC etc would popup in an automated documents-search I used at that
  time) to a batchfile. After a time, I started to hate the editing, and
  I made this specialized editor. This is a second version, the old
  pulldown is eliminated, and replaced by the new version, which is
  really sophisticated. This program doesn't use the real features of the
  new PullDown (recursion, and flexibility) since the pulldownmenu is very
  simple.

I think this is the most usefull demo, check out the variable "Dos" to disable
 NDOS/4DOS commands (restoration of directory after execution). I don't know
 how many things (paths, filenames) are hardcoded in, but I'm pretty sure
 several comments and procedure/variable names are still Dutch, but it isn't
 that crucial since this module is pretty straightforward except for
 PullDown, in which I'm about to translate the comments.
 Oops, by the way, the "program info" menu option is not ready yet, since
 I wanted to implement a Windowed help-module for it, but I never started
 programming it :-)

Ooh, by the way 2, if you want to start a batchfile, prefix the startup-filename
with call, e.g. "call startTs.bat".  *)

FROM GeLib IMPORT VraagVeld,About,
                    InvoerRec,Hoofd,Cyfer,Leest,Klein;
FROM IO     IMPORT WrStr,WrLn,WrChar,WrCharRep;
FROM Str    IMPORT Length,Caps,Concat,Delete,CHARSET,Compare,CardToStr,Pos,ItemS,Lows;
FROM Lib    IMPORT WordFill,Fill;
FROM CoreCrt IMPORT ScrollDown,ScrollUp,BlinkOff;

FROM PullDown IMPORT Style2,Style4,PullHandle,PullOpen,
                      PullDef,ColT,ClrScrF,PullObject,GetPullKey,PullClose;
FROM Window IMPORT WinDef,WinType,GotoXY,TextColor,Color,TextBackground,
                    CursorOn,
                    Black,White,LightGray,DarkGray,Red,Yellow;
FROM ELib IMPORT GetKey,FileBufType,KillBChar;
FROM MLib IMPORT FindInPath;

IMPORT FIO,Storage,Window,PullDown,GeMenu;

CONST
      (*  Commando Balk *)

      StatusLine="Esc=Exit  Ins=Insert Enter=Change  Del=Delete  ALT F ALT E ALT H: Menu";
      StatusCol =8*16+4;

      FFCol=White;
      BBCol=Black;

      (* Kleur KiesBalk *)

      HiCol=Color(1);
      HiBack=Green;

      (* Kleur Rand om scherm *)

      RandKl=White;
      ScrollKl=LightGray;
      ScrollHiKl=Yellow;
      StyleT=PullDown.Style4;

      (* kleur InvoerVeld vraag *)

      InVeldKl=Red;

      FillCh  = "";

    (* Tlib *)

    CR      = 0DH;                AltF= 2100H;
    ESC     = 1BH;                AltE= 1200H;
    Insert  = 05200H;             AltH= 2300H;
    DELete  = 05300H;
    ArrU    = 04800H;
    ArrD    = 05000H;
    F5      = 3F00H;
    F10     = 4400H;


TYPE StrType = ARRAY[1..40] OF CHAR;
     Rec=RECORD
          Path  : StrType;      (* Path van de file om op te starten *)
          SName : StrType;      (* Naam "   "    "   "  "  "    "*)
          Name  : StrType;      (* Volledige naam file(voor in menu*)
          Afk   : ARRAY[1..4] OF CHAR; (* Afkorting om file mee op te starten
                                           deze moet uniek zijn*)
          END;

VAR Dos: BOOLEAN; (* als TRUE dan 4DOS CDD, PushD PopD *)

PROCEDURE WrLine(FCol,BCol:Color;Positie,B:CARDINAL;IArr:ARRAY OF Rec); (* Record op scherm zetten*)

CONST I=3;
VAR A: CARDINAL;

BEGIN
 TextColor(FCol);
 TextBackground(BCol);
 GotoXY(2,Positie+I);
 WrCharRep(" ",76);
 WITH IArr[B] DO
  GotoXY(3,Positie+I);        WrStr(Name);
  GotoXY(31,Positie+I);       WrStr(Afk);
  GotoXY(36,Positie+I);       WrStr(SName);
  GotoXY(55,Positie+I);       WrStr(Path);
  END;
 TextColor(ScrollKl);
 TextBackground(BBCol);
 Window.GotoXY(78,3);         WrChar(CHR(30));
 Window.GotoXY(78,22);        WrChar(CHR(31));
END WrLine;

PROCEDURE WrLst (Getal,Aanta:CARDINAL;FCol,BCol :Color;NoTop:CARDINAL;ArrI:ARRAY OF Rec);

VAR A,Dummy:CARDINAL;
 	
BEGIN
 PullDown.ClrScrF;
 WrLn;
 WrStr("   Naam                        Afk  Startopnaam        Path");
 TextColor(RandKl);
 Window.GotoXY(0,1);
 WrChar(StyleT[4]);
 Window.GotoXY(79,1);
 WrChar(StyleT[4]);
 FOR A:= 3 TO 23 DO
  TextColor(RandKl);
  GotoXY(0,A);
  WrChar(StyleT[4]);
  GotoXY(79,A);
  WrChar(StyleT[4]);
  TextColor(ScrollKl);
  GotoXY(78,A);
  WrChar(FillCh);
  END;
 TextColor(RandKl);
 GotoXY(1,0);
 WrCharRep(StyleT[3],78);
 GotoXY(1,2);
 WrCharRep(StyleT[3],78);
 GotoXY(1,24);
 WrCharRep(StyleT[3],78);
 GotoXY( 0, 2);
 WrStr(StyleT[2]);
 GotoXY(79, 2);
 WrChar(StyleT[1]);
 GotoXY( 0,24);
 WrChar(StyleT[5]);
 GotoXY( 0, 0);
 WrChar(StyleT[6]);
 GotoXY(79,24);
 WrChar(StyleT[7]);
 GotoXY(79, 0);
 WrChar(StyleT[0]);
 Dummy:=Aanta-NoTop;
 IF Dummy>20 THEN
  Dummy:=20;
  END;
 IF Dummy>0 THEN
  FOR A:= 0 TO Dummy-1 DO
   WrLine(FCol,BCol,A,NoTop+A,ArrI);
   END;
  END;
END WrLst;

PROCEDURE Sort(VAR ArrI:ARRAY OF Rec;Aanta:CARDINAL);

 (* BubbleSort ArrI with Aanta records. *)

VAR A,B        : CARDINAL;
    TRec       : Rec;                    (* Temporary record to sort with*)

BEGIN
 FOR A:= 0 TO Aanta-2 DO            (* Bubble Sortje *)
  FOR B:= 0 TO Aanta-2 DO
   IF Compare(ArrI[B].Name,ArrI[B+1].Name)=1 THEN
    TRec:=ArrI[B];
    ArrI[B]:=ArrI[B+1];
    ArrI[B+1]:=TRec;
    END;
   END;
  END;
END Sort;

PROCEDURE SaveYn():BOOLEAN;

VAR Yn,Fl      : BOOLEAN;
    A	       : CARDINAL;
    Win : WinType;

CONST WD=WinDef(20,10,60,14,Yellow,LightGray,FALSE,TRUE,FALSE,TRUE,
                Window.DoubleFrame,Yellow,LightGray);

BEGIN
 Win := Window.Open(WD) ;
 Window.SetTitle(Win,' Save? ',Window.CenterUpperTitle);
 Window.Use(Win);
 GotoXY(4,2);
 WrStr("Do you want to save the file(Y/N)?");
 Fl:=FALSE;
 WHILE Fl=FALSE DO
  A:=GetKey();
  CASE A OF
   | 89 : Yn:=TRUE;
   	  Fl:=TRUE;
   | 121: Yn:=TRUE;
   	  Fl:=TRUE;
   | 110: Yn:=FALSE;
   	  Fl:=TRUE;  	
   | 78 : Yn:=FALSE;
   	  Fl:=TRUE;
   END;
  END;
 Window.Close(Win);
RETURN Yn;
END SaveYn;

PROCEDURE GetRec(Gnr: CARDINAL;Wel:BOOLEAN;VAR ArrI:ARRAY OF Rec);
 (* laat record invoeren en schrijf het op plaats Gnr in de lijst ArrI*)
VAR InRec      : InvoerRec;
    OK         : BOOLEAN;
    Win : WinType;

CONST WD=WinDef(3,9,65,14,Yellow,LightGray,FALSE,TRUE,FALSE,TRUE,
                Window.DoubleFrame,Yellow,LightGray);

BEGIN
 Win := Window.Open(WD) ;
 Window.SetTitle(Win,' Input Program ',Window.CenterUpperTitle);
 Window.Use(Win);
 CursorOn;
 WITH ArrI[Gnr-1] DO
  InRec.Toegest:=CHARSET{"\"," "}+Hoofd+Klein+Cyfer+Leest;
  InRec.Flags[0]:=TRUE;
  InRec.Flags[1]:=TRUE;
  InRec.X:=39;

  InRec.Len:=20;
  IF Wel=FALSE THEN
   Path:="";
   SName:="";
   Name:="";
   Afk:="";
   END;
  TextColor(InVeldKl);
  InRec.Y:=1;
  GotoXY(1,1);
  WrStr("Path of file to run : ");
  OK:=VraagVeld(InRec,Path);
  InRec.Y:=2;
  GotoXY(1,2);
  WrStr("File to run : ");
  OK:=VraagVeld(InRec,SName);
  InRec.Y:=3;
  GotoXY(1,3);
  WrStr("Name file to display in the menu : ");
  OK:=VraagVeld(InRec,Name);
  InRec.Len:=4;
  InRec.Y:=4;
  GotoXY(1,4);
  WrStr("Abbreviation :");
  OK:=VraagVeld(InRec,Afk);
  (* Haal evt overbodige spaties weg *)
  KillBChar(Path,CHARSET{" "});
  KillBChar(Name,CHARSET{" "});
  KillBChar(SName,CHARSET{" "});
  KillBChar(Afk,CHARSET{" "});
  Lows(Afk);                      (* Maak Afk lowercase *)
  Caps(SName);
  Caps(Path);
  END;
 Window.Close(Win);
 END GetRec;

PROCEDURE Make(PathTo:ARRAY OF CHAR;ArrI:ARRAY OF Rec;Aanta:CARDINAL);

VAR F	       : FIO.File;
    B1         : FileBufType;         (* Diskbuffer*)
    S	       : ARRAY[1..200] OF CHAR;
    A,B,C      : CARDINAL;
    Fl	       : BOOLEAN;
    S1,S2      : ARRAY[1..200] OF CHAR;

    	
BEGIN
 Concat(S,PathTo,"\G.Bat");
 F:=FIO.Create(S);
 FIO.AssignBuffer(F,B1);
 FIO.WrStr(F,"@ECHO OFF");
 FIO.WrLn(F);
 FIO.WrStr(F,"PUSHD");
 FIO.WrLn(F);
 FIO.WrStr(F,'IF "%1"=="" GOTO MENU');
 FIO.WrLn(F);
 FOR A:= 0 TO Aanta-1 DO
  Lows(ArrI[A].Afk);
  FIO.WrStr(F,'IF "%1"=="');
  FIO.WrStr(F,ArrI[A].Afk);
  FIO.WrStr(F,'" GOTO ');
  FIO.WrCard(F,A,3);
  FIO.WrLn(F);
  END;
 FIO.WrStr(F,":MENU");
 FIO.WrLn(F);
 FIO.WrStr(F,"ECHO         *** OPTIONS ***");
 FIO.WrLn(F);
 FIO.WrStr(F,"ECHO .");
 FIO.WrLn(F);
 FOR A:= 0 TO Aanta-1 DO
  FIO.WrStr(F,"ECHO   ");
  Caps(ArrI[A].Afk);
  FIO.WrStr(F,ArrI[A].Afk);
  C:=8-Length(ArrI[A].Afk);
  FIO.WrCharRep(F," ",C);
  FIO.WrStr(F,"=    ");
  FIO.WrStr(F,ArrI[A].Name);
  FIO.WrLn(F);
  END;
 FIO.WrStr(F,"GOTO LEND");
 FIO.WrLn(F);
 FOR A:= 0 TO Aanta-1 DO
  FIO.WrStr(F,":");
  CardToStr(LONGCARD(A),S,10,Fl);
  FIO.WrStr(F,S);
  FIO.WrLn(F);
  IF Dos=TRUE THEN
   FIO.WrStr(F,"CDD ");
   FIO.WrStr(F,ArrI[A].Path);

  ELSE
   C:=Pos(ArrI[A].Path,":");
   IF C=65535 THEN
    FIO.WrStr(F,"CD ");
    FIO.WrStr(F,ArrI[A].Path);
   ELSE
    FIO.WrChar(F,ArrI[A].Path[1]);
    FIO.WrChar(F,":");
    FIO.WrLn(F);
    FIO.WrStr(F,"CD ");
    Concat(S2,ArrI[A].Path,"");
    Delete(S2,0,2);
    FIO.WrStr(F,S2);
    END;
   END;
  FIO.WrLn(F);
  FIO.WrStr(F,ArrI[A].SName);
  FIO.WrLn(F);
  FIO.WrStr(F,"GOTO END");
  FIO.WrLn(F);
  END;
 FIO.WrStr(F,":END");
 FIO.WrLn(F);
 FIO.WrStr(F,"POPD");
 FIO.WrLn(F);
 FIO.WrStr(F,":LEND");
 FIO.Close(F);
END Make;

PROCEDURE LeesFile(FileN:ARRAY OF CHAR;VAR Aantal:CARDINAL;VAR ArrI:ARRAY OF Rec);

VAR F: FIO.File;
    B1         : FileBufType;         (* Diskbuffer*)

BEGIN
 IF FIO.Exists(FileN) THEN
  F:=FIO.Open(FileN);
  FIO.AssignBuffer(F,B1);
  Aantal:=0;
  LOOP
   WITH ArrI[Aantal] DO
    FIO.RdStr(F,Path);
    FIO.RdStr(F,SName);
    FIO.RdStr(F,Name);
    FIO.RdStr(F,Afk);
    END;
   IF FIO.EOF THEN
    EXIT
    END;
   INC(Aantal);
   END;
  FIO.Close(F);
 ELSE
  Aantal:=0;
  END;
END LeesFile;	

PROCEDURE SchrijfFile(PathToNfo,PathTo:ARRAY OF CHAR;Aanta:CARDINAL;ArrI:ARRAY OF Rec);

VAR F	       : FIO.File;
    B1         : FileBufType;            (* Diskbuffer*)
    S 	       : ARRAY[1..200] OF CHAR;  (* Tijdelijke Strings *)
    A	       : CARDINAL;

BEGIN
 Concat(S,PathTo,"\G.Bak");           (* Schrijven*)
 IF FIO.Exists(S) THEN
  FIO.Erase(S);
  END;
 FIO.Rename(PathToNfo,S);
 F:=FIO.Create(PathToNfo);
 FIO.AssignBuffer(F,B1);
 FOR A:= 0 TO Aanta-1 DO
  FIO.WrStr(F,ArrI[A].Path);
  FIO.WrLn(F);
  FIO.WrStr(F,ArrI[A].SName);
  FIO.WrLn(F);
  FIO.WrStr(F,ArrI[A].Name);
  FIO.WrLn(F);
  FIO.WrStr(F,ArrI[A].Afk);
  FIO.WrLn(F);
  END;
 FIO.Close(F);
END SchrijfFile;

PROCEDURE WrSpot(NoTop,Aant,Ca:CARDINAL;FCol:Color);

VAR Lo : CARDINAL;

BEGIN
 IF (Ca+NoTop)=0 THEN
  Lo:=4;
 ELSE
  Lo:=((18*(Ca+NoTop)) DIV Aant)+3;
  END;
 TextColor(FCol);
 GotoXY(78,Lo);
 WrChar(FillCh);
END WrSpot;

PROCEDURE Displ();

CONST Space=CHR(32);

VAR I : CARDINAL;


BEGIN
 TextColor(Window.Color(StatusCol));
 GotoXY(2,23);
 WrCharRep(Space,77);
 GotoXY((78-Length(StatusLine)) DIV 2+1,23);
 WrStr(StatusLine);
END Displ;



(* Globale Variabelen *)

VAR Arr        : ARRAY[1..200] OF Rec;   (* Record lijst *)
    Aant,NoTop,                          (* Aantal ingevoerde records *)
    Field,                               (* Record waar de balk op staat*)
    A,B        : CARDINAL;               (* counters en tijdelijke variabelen*)
    PathTo,
    PathToNfo : ARRAY[1..50] OF CHAR;  (* Paths van files en van G.NFO *)
    Saved      : BOOLEAN;    		(* File Saved YN? *)
    H          : PullHandle;

    Fl         : BOOLEAN;

PROCEDURE ReWrite(No:CARDINAL);

BEGIN
   WrLst(No,Aant,FFCol,BBCol,NoTop,Arr);				(* Lijst op scherm *)
   Displ();		              	(* Statusbalk *)
   WrSpot(NoTop,Aant,Field,ScrollHiKl);      (* ScrollBalk *)
   WrLine(HiCol,HiBack,Field,NoTop+Field,Arr);
END ReWrite;

PROCEDURE DoPull(B,H :CARDINAL):CARDINAL;

BEGIN
 CASE B OF
 |    GeMenu.Load  :   LeesFile(PathToNfo,Aant,Arr);         (*  Lezen *)
                       NoTop:=0;
                       Field:=1;
                       ReWrite(NoTop);
                       Saved:=TRUE;
 |    GeMenu.Save  :   SchrijfFile(PathToNfo,PathTo,Aant,Arr);
                       Saved:=TRUE;
 |    GeMenu.End   :   ClrScrF;                           (* Einde *)
                       CursorOn;
                       PullClose(H);
                       HALT;
 |    GeMenu.MakeQuit: Sort(Arr,Aant);
                       Make(PathTo,Arr,Aant);
                       SchrijfFile(PathToNfo,PathTo,Aant,Arr);
                       ClrScrF;
                       CursorOn;
                       PullClose(H);
                       HALT;
 |    GeMenu.Make:     Make(PathTo,Arr,Aant);            (* Creer BAT *)
 |    GeMenu.Sort    : Sort(Arr,Aant);  (* Bubble Sortje *)
                       ReWrite(NoTop);
                       Saved:=FALSE;
 |    GeMenu.About  : About;
 |    GeMenu.Other   : About;
               END;
 RETURN 0;
END DoPull;


TYPE PositionsType=ARRAY[1..3] OF BYTE;

CONST
       PullD=PullDef(ColT(LightMagenta,Yellow,DarkGray,White,Red,LightGray,White,DarkGray,LightGray,
              White,DarkGray,Style2),TRUE,22,DoPull,NULLPROC,NULLPROC);
       Posi=PositionsType(1,15,75);

PROCEDURE Pull(TopNr:CARDINAL);

BEGIN

 H:=PullOpen(PullObject(GeMenu.GePull),PullD);
 PullDown.SetPositions(H,Posi);
 A:=GetPullKey(H,TopNr);
 PullClose(H);
END Pull;

BEGIN
 (* Initialisatie *)

 BlinkOff;
 Window.CursorOff;

 (* Zoek G.NFO in het path *)

 FindInPath("G.NFO",PathTo);
 Delete(PathTo,Length(PathTo)-6,6);
 Concat(PathToNfo,PathTo,"\G.Nfo");

 (* SchermSchoonmaak *)

 ClrScrF;

 (* Initialisatie belangrijke variabelen *)

 Aant:=0;               (* 0 records initialisatie *)

 Field:=0;              (* Record 1 standaard *)

 NoTop:=0;              (* 1e record op scherm is eerste record in array *)

 Saved:=TRUE;		(* Ivm 'Not saved, do you wanna save?' vraag *)

 Dos:=FALSE; 		(* 4dos niet aanwezig(FALSE) *);

 (* Lezen G.NFO *)

 LeesFile(PathToNfo,Aant,Arr);

 (* Construeer Scherm *)

 ReWrite(NoTop);

 (* Start hoofdprogramma Loop *)

 About;
 LOOP
  A:=GetKey();               (* Toets van toetsenbord afhalen *)
  CASE A OF

 |     Insert  : Aant:=Aant+1;                            (* INSERT *)
                 GetRec(Aant,FALSE,Arr);
                 ReWrite(NoTop);
                 Saved:=FALSE;
 |     CR      : GetRec(Field+1+NoTop,TRUE,Arr);              (* Enter Wijzig *)
                 WrLine(HiCol,HiBack,Field,NoTop+Field,Arr);
	 	 Saved:=FALSE;
 |     ArrU    : IF Field>0 THEN
                  WrLine(FFCol,BBCol,Field,NoTop+Field,Arr);
                  WrSpot(NoTop,Aant,Field,ScrollKl);
                  DEC(Field);
                  WrSpot(NoTop,Aant,Field,ScrollHiKl);
                  WrLine(HiCol,HiBack,Field,NoTop+Field,Arr);
                 ELSIF (NoTop>0) THEN
                  WrLine(FFCol,BBCol,Field,NoTop+Field,Arr);
                  WrSpot(NoTop,Aant,Field,ScrollKl);
                  DEC(NoTop);
                  ScrollDown(1,2,76,21,1);
                  Field:=0;
                  WrLine(FFCol,BBCol,0,NoTop+0,Arr);
                  WrSpot(NoTop,Aant,Field,ScrollHiKl);
                  WrLine(HiCol,HiBack,Field,NoTop+Field,Arr);
                  END;
 |     ArrD    : IF (Field<19) AND ((Aant-1)>(Field)) THEN        (* Omlaag *)
                  WrLine(FFCol,BBCol,Field,NoTop+Field,Arr);
                  WrSpot(NoTop,Aant,Field,ScrollKl);
                  INC(Field);
                  WrSpot(NoTop,Aant,Field,ScrollHiKl);
                  WrLine(HiCol,HiBack,Field,NoTop+Field,Arr);
                 ELSIF ((NoTop+20)<Aant) THEN
                  WrSpot(NoTop,Aant,Field,ScrollKl);
                  WrLine(FFCol,BBCol,Field,NoTop+Field,Arr);
                  INC(NoTop);
                  ScrollUp(1,2,76,21,1);

                  WrLine(FFCol,BBCol,19,NoTop+19,Arr);
                  WrSpot(NoTop,Aant,Field,ScrollHiKl);
                  WrLine(HiCol,HiBack,Field,NoTop+Field,Arr);
                  END;
 |     F5      : IF Saved=FALSE THEN
 		  Fl:=SaveYn();
 		  IF Fl=TRUE THEN
 		   SchrijfFile(PathToNfo,PathTo,Aant,Arr);
 		   END;
 		  END;
 		 ClrScrF;
                 EXIT;                                  (* F5 EXIT *)
 |     ESC     : IF Saved=FALSE THEN
 		  Fl:=SaveYn();
 		  IF Fl=TRUE THEN
 		   SchrijfFile(PathToNfo,PathTo,Aant,Arr);
 		   END;
 		  END;
 		 ClrScrF;
                 EXIT;
 |     DELete  : IF Aant>0 THEN
                  WrSpot(NoTop,Aant,Field,ScrollKl);
                  Arr[NoTop+Field+1]:=Arr[Aant];        (* Del DELETE *)
                  DEC(Aant);
                  IF (NoTop+Field)>(Aant-2) THEN
                   Field:=Aant-NoTop-1;
                   END;
                  IF NoTop>0 THEN
                   DEC(NoTop);
                   END;
                  ReWrite(NoTop);
                  WrSpot(NoTop,Aant,Field,ScrollHiKl);
                  END;
                  Saved:=FALSE;
 |   AltF      :  Pull(1);
 |   AltE      :  Pull(2);
 |   AltH      :  Pull(3);
   END;
  END;
  CursorOn;
END GE.