MODULE JpiDem;

FROM PullDown IMPORT PullOpen,PullHandle,GetPullKey,PullClose,PullDef,ColT,Style3,
                     PullObject,OnOffItem,StType,GetObjAddr,Toggler;
FROM Lib IMPORT EnableBreakCheck;
FROM ELib IMPORT GetKey;
FROM Str IMPORT Length,CharPos;
FROM Window IMPORT WinType,Color;
FROM TSMAIN IMPORT SetupOptions;

IMPORT IO,Menu3,Window,PullDown;

(* Two types (actually one, but StrArr is not used separately),
    needed for accessing textual constants without copying*)

TYPE    StrArr  = ARRAY[0..400] OF CHAR;
        StrPoint= POINTER TO StrArr;

CONST WrLn=CHR(13)+CHR(10); (* To ease definition, not used separately*)

      (* Some helptexts, with linefeeds integrated. You must format (align
         and wrap) them yourself, but that's a limitation of a JpiDem
         procedure, not PullDown itself, a real wrapper is build into
         WordW.MOD *)

       (* Statusline on the bottom of the screen *)
      StatusLine="Esc=Exit  F1=Context-sensitive help";

VAR Vid,
    System,
    MemModel : CARDINAL;
    Target   : CARDINAL;

PROCEDURE WrLab(S:ARRAY OF CHAR);
(* Rough procedure, writes the S on a certain spot to the screen*)

BEGIN
 Window.Use (Window.FullScreen);
 Window.GotoXY(40,20);
 Window.TextColor(LightGray);
 IO.WrCharRep(CHR(177),40);
 Window.GotoXY(40,20);
 Window.TextColor(Magenta);
 IO.WrStr("Last picked label : ");
 Window.TextColor(Green);
 IO.WrStr(S);
END WrLab;

(* Window definition for an helpwindow*)
CONST HelpDef=Window.WinDef(20,4,65,8,White,Black,FALSE,TRUE,FALSE,TRUE,
                            Window.DoubleFrame,Yellow,Black);

PROCEDURE WrHelp(S:ARRAY OF CHAR);
(* Create a small helpwindow and put the argument text in it *)

VAR L : WinType;
    A : CARDINAL;

BEGIN
 L:=Window.Open(HelpDef);
 Window.Use (L);
 IO.WrLn;
 IO.WrStr("This is the help for : ");
 IO.WrStr(S);
 A:=GetKey();
 Window.Close(L);
END WrHelp;

PROCEDURE WrHelpSys(Label:CARDINAL);
(* Create a small helpwindow and put the argument text in it *)

VAR L : WinType;
    A : CARDINAL;

BEGIN
 L:=Window.Open(HelpDef);
 Window.Use (L);
 IO.WrLn;
 IO.WrStr("This is the help for : ");
 A:=GetKey();
 Window.Close(L);
END WrHelpSys;


PROCEDURE OtherHelp(Pnt : StrPoint);
(* A little bit more advanced procedure, writes several lines of help,
   Very limited, is only 5 lines :-) *)

VAR L : WinType;
    A : CARDINAL;

BEGIN
 L:=Window.Open(HelpDef);
 Window.Use (L);
 IO.WrStr(Pnt^);
 A:=GetKey();
 Window.Close(L);
END OtherHelp;

PROCEDURE WrSelect(S:ARRAY OF CHAR);
(* PullDown version of write select test*)

BEGIN
 Window.CursorOff;
 Window.GotoXY(10,23); Window.TextColor(Window.Blue); IO.WrCharRep("",50);
 Window.GotoXY(10,23); Window.TextColor(Yellow);      IO.WrStr(S);
END WrSelect;

PROCEDURE DoPull(InCode,H:CARDINAL):CARDINAL;
(* Called when a pulldown menu item is selected *)

VAR A : CARDINAL;

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu3.Asciitab          :    WrLab("Asciitab");
   | Menu3.Bottom_Scroll_Zone:    WrLab("Bottom_Scroll_Zone");
   | Menu3.Calculator        :    WrLab("Calculator");
   | Menu3.ChangeDir         :    WrLab("ChangeDir");
   | Menu3.Command_Line      :    WrLab("Command_Line");
   | Menu3.Default_Extensions:    WrLab("Default_Extensions");
   | Menu3.Default_Filenames :    WrLab("Default_Filenames:");
   | Menu3.Directory         :    WrLab("Directory");
   | Menu3.DOSShell          :    WrLab("DOSShell");
   | Menu3.EdDelEndLine      :    WrLab("EdDelEndLine");
   | Menu3.EdEndFile         :    WrLab("EdEndFile");
   | Menu3.EdEndLine         :    WrLab("EdEndLine");
   | Menu3.EdEndScreen       :    WrLab("EdEndScreen");
   | Menu3.EdFind            :    WrLab("EdFind");
   | Menu3.EdGotoBegin_Block :    WrLab("EdGotoBegin_Block");
   | Menu3.EdGotoEnd_Block   :    WrLab("EdGotoEnd_Block");
   | Menu3.EdGotoLine        :    WrLab("EdGotoLine");
   | Menu3.EdGotoM1          :    WrLab("EdGotoM1");
   | Menu3.EdGotoM2          :    WrLab("EdGotoM2");
   | Menu3.EdLoadFile        :    WrLab("EdLoadFile");
   | Menu3.EdLoadFRO         :    WrLab("EdLoadFRO");
   | Menu3.EdOptC            :    OnOffItem(H,Menu3.EdOptC); RETURN 1;
   | Menu3.EdOptI            :    OnOffItem(H,Menu3.EdOptI); RETURN 1;
   | Menu3.EdOptT            :    OnOffItem(H,Menu3.EdOptT); RETURN 1;
   | Menu3.EdOptU            :    OnOffItem(H,Menu3.EdOptU); RETURN 1;
   | Menu3.EdOptV            :    OnOffItem(H,Menu3.EdOptV); RETURN 1;
   | Menu3.EdOpt_A           :    WrLab("EdOpt_A");
   | Menu3.EdPrevPosition    :    WrLab("EdPrevPosition");
   | Menu3.EdReplace         :    WrLab("EdReplace");
   | Menu3.EdRestoreLine     :    WrLab("EdRestoreLine");
   | Menu3.EdStartFile       :    WrLab("EdStartFile");
   | Menu3.EdStartLine       :    WrLab("EdStartLine");
   | Menu3.EdStartScreen     :    WrLab("EdStartScreen");
   | Menu3.EdWriteFile       :    WrLab("EdWriteFile");
   | Menu3.Ed_Begin_Block    :    WrLab("Ed_Begin_Block");
   | Menu3.Ed_Copy_Block     :    WrLab("Ed_Copy_Block");
   | Menu3.Ed_Del_Block      :    WrLab("Ed_Del_Block");
   | Menu3.Ed_End_Block      :    WrLab("Ed_End_Block");
   | Menu3.Ed_Get_Block      :    WrLab("Ed_Get_Block");
   | Menu3.Ed_Hide_Block     :    WrLab("Ed_Hide_Block");
   | Menu3.Ed_Indent_Block   :    WrLab("Ed_Indent_Block");
   | Menu3.Ed_Mark_Line      :    WrLab("Ed_Mark_Line");
   | Menu3.Ed_Mark_Word      :    WrLab("Ed_Mark_Word");
   | Menu3.Ed_Move_Block     :    WrLab("Ed_Move_Block");
   | Menu3.Ed_Print_Block    :    WrLab("Ed_Print_Block");
   | Menu3.Ed_Quit           :    WrLab("Ed_Quit");
   | Menu3.Ed_Read_Block     :    WrLab("Ed_Read_Block");
   | Menu3.Ed_Set_M1         :    WrLab("Ed_Set_M1");
   | Menu3.Ed_Set_M2         :    WrLab("Ed_Set_M2");
   | Menu3.Ed_Tab_Width      :    OnOffItem(H,Menu3.Ed_Tab_Width); RETURN 1;
   | Menu3.Ed_Undo           :    WrLab("Ed_Undo");
   | Menu3.Ed_Write_Block    :    WrLab("Ed_Write_Block");
   | Menu3.EnvOpt_C          :    OnOffItem(H,Menu3.EnvOpt_C); RETURN 1;
   | Menu3.EnvOpt_D          :    OnOffItem(H,Menu3.EnvOpt_D); RETURN 1;
   | Menu3.EnvOpt_E          :    OnOffItem(H,Menu3.EnvOpt_E); RETURN 1;
   | Menu3.EnvOpt_H          :    OnOffItem(H,Menu3.EnvOpt_H); RETURN 1;
   | Menu3.EnvOpt_L          :    OnOffItem(H,Menu3.EnvOpt_L); RETURN 1;
   | Menu3.EnvOpt_M          :    OnOffItem(H,Menu3.EnvOpt_M); RETURN 1;
   | Menu3.EnvOpt_N          :    OnOffItem(H,Menu3.EnvOpt_N); RETURN 1;
   | Menu3.EnvOpt_Q          :    OnOffItem(H,Menu3.EnvOpt_Q); RETURN 1;
   | Menu3.EnvOpt_R          :    OnOffItem(H,Menu3.EnvOpt_R); RETURN 1;
   | Menu3.EnvOpt_S          :    OnOffItem(H,Menu3.EnvOpt_S); RETURN 1;
   | Menu3.EnvOpt_S2         :    OnOffItem(H,Menu3.EnvOpt_S2);RETURN 1;
   | Menu3.EnvOpt_U          :    OnOffItem(H,Menu3.EnvOpt_U); RETURN 1;
   | Menu3.EnvOpt_V          :    OnOffItem(H,Menu3.EnvOpt_V); RETURN 1;
   | Menu3.EnvOpt_W          :    OnOffItem(H,Menu3.EnvOpt_W); RETURN 1;
   | Menu3.Execute           :    WrLab("Execute");
   | Menu3.Find_Error        :    WrLab("Find_Error");
   | Menu3.Help              :    WrLab("Help");
   | Menu3.Info              :    WrLab("Info");
   | Menu3.LoadFile          :    WrLab("LoadFile");
   | Menu3.LoadF_RO          :    WrLab("LoadF_RO");
   | Menu3.Load_Config_File  :    WrLab("Load_Config_File");
   | Menu3.Load_Macs         :    WrLab("Load_Macs");
   | Menu3.Load_Red_File     :    WrLab("Load_Red_File");
   | Menu3.Locate_File       :    WrLab("Locate_File");
   | Menu3.MakeOptSystem     :    System:=(System+1) AND 3;
                                  Toggler(H,Menu3.MakeOptSystem,System,"dos@win@os2@auto");
                                  RETURN 1;
   | Menu3.MakeOptTarget     :    Target:=(Target+1) MOD 3;
                                  Toggler(H,Menu3.MakeOptTarget,Target,"exe@lib@dll");
                                  RETURN 1;
   | Menu3.MakeOptvid        :    Vid:=(Vid+1) MOD 3;
                                  Toggler(H,Menu3.MakeOptvid,Vid,"off@min@full");
                                  RETURN 1;
   | Menu3.MakeOpt_alias     :    OnOffItem(H,Menu3.MakeOpt_alias);   RETURN 1;
   | Menu3.MakeOpt_ansi      :    OnOffItem(H,Menu3.MakeOpt_ansi);    RETURN 1;
   | Menu3.MakeOpt_bit_opr   :    OnOffItem(H,Menu3.MakeOpt_bit_opr); RETURN 1;
   | Menu3.MakeOpt_case      :    OnOffItem(H,Menu3.MakeOpt_case);    RETURN 1;
   | Menu3.MakeOpt_const     :    OnOffItem(H,Menu3.MakeOpt_const);   RETURN 1;
   | Menu3.MakeOpt_copro     :    OnOffItem(H,Menu3.MakeOpt_copro);   RETURN 1;
   | Menu3.MakeOpt_cpu       :    OnOffItem(H,Menu3.MakeOpt_cpu);     RETURN 1;
   | Menu3.MakeOpt_field     :    OnOffItem(H,Menu3.MakeOpt_field);   RETURN 1;
   | Menu3.MakeOpt_guard     :    OnOffItem(H,Menu3.MakeOpt_guard);   RETURN 1;
   | Menu3.MakeOpt_incl_cmt  :    OnOffItem(H,Menu3.MakeOpt_incl_cmt);RETURN 1;
   | Menu3.MakeOpt_index     :    OnOffItem(H,Menu3.MakeOpt_index);   RETURN 1;
   | Menu3.MakeOpt_iso       :    OnOffItem(H,Menu3.MakeOpt_iso);     RETURN 1;
   | Menu3.MakeOpt_jpi       :    OnOffItem(H,Menu3.MakeOpt_jpi);     RETURN 1;
   | Menu3.MakeOpt_jump      :    OnOffItem(H,Menu3.MakeOpt_jump);    RETURN 1;
   | Menu3.MakeOpt_lang_ext  :    OnOffItem(H,Menu3.MakeOpt_lang_ext);RETURN 1;
   | Menu3.MakeOpt_loop      :    OnOffItem(H,Menu3.MakeOpt_loop);    RETURN 1;
   | Menu3.MakeOpt_map       :    OnOffItem(H,Menu3.MakeOpt_map);     RETURN 1;
   | Menu3.MakeOpt_min_line  :    OnOffItem(H,Menu3.MakeOpt_min_line);RETURN 1;
   | Menu3.MakeOpt_nest_cmt  :    OnOffItem(H,Menu3.MakeOpt_nest_cmt);RETURN 1;
   | Menu3.MakeOpt_nil_ptr   :       OnOffItem(H,Menu3.MakeOpt_nil_ptr); RETURN 1;
   | Menu3.MakeOpt_overflow  :    OnOffItem(H,Menu3.MakeOpt_overflow);RETURN 1;
   | Menu3.MakeOpt_peep      :    OnOffItem(H,Menu3.MakeOpt_peep);    RETURN 1;
   | Menu3.MakeOpt_pre_proc  :    OnOffItem(H,Menu3.MakeOpt_pre_proc);RETURN 1;
   | Menu3.MakeOpt_prototypes:    OnOffItem(H,Menu3.MakeOpt_prototypes);RETURN 1;
   | Menu3.MakeOpt_range     :    OnOffItem(H,Menu3.MakeOpt_range);    RETURN 1;
   | Menu3.MakeOpt_regass    :    OnOffItem(H,Menu3.MakeOpt_regass);   RETURN 1;
   | Menu3.MakeOpt_share_c   :    OnOffItem(H,Menu3.MakeOpt_share_c);  RETURN 1;
   | Menu3.MakeOpt_smart_link:    OnOffItem(H,Menu3.MakeOpt_smart_link);RETURN 1;
   | Menu3.MakeOpt_smart_m   :    OnOffItem(H,Menu3.MakeOpt_smart_m);   RETURN 1;
   | Menu3.MakeOpt_stack     :    OnOffItem(H,Menu3.MakeOpt_stack);     RETURN 1;
   | Menu3.MakeOpt_stk_frame :    OnOffItem(H,Menu3.MakeOpt_stk_frame); RETURN 1;
   | Menu3.MakeOpt_subexpr   :    OnOffItem(H,Menu3.MakeOpt_subexpr);   RETURN 1;
   | Menu3.MakeOpt_uns_char  :    OnOffItem(H,Menu3.MakeOpt_uns_char);  RETURN 1;
   | Menu3.MakeOpt_wacc      :    OnOffItem(H,Menu3.MakeOpt_wacc);      RETURN 1;
   | Menu3.MakeOpt_wait      :    OnOffItem(H,Menu3.MakeOpt_wait);      RETURN 1;
   | Menu3.MakeOpt_watr      :    OnOffItem(H,Menu3.MakeOpt_watr);      RETURN 1;
   | Menu3.MakeOpt_wcic      :    OnOffItem(H,Menu3.MakeOpt_wcic);      RETURN 1;
   | Menu3.MakeOpt_wcld      :    OnOffItem(H,Menu3.MakeOpt_wcld);      RETURN 1;
   | Menu3.MakeOpt_wclt      :    OnOffItem(H,Menu3.MakeOpt_wclt);      RETURN 1;
   | Menu3.MakeOpt_wcne      :    OnOffItem(H,Menu3.MakeOpt_wcne);      RETURN 1;
   | Menu3.MakeOpt_wcor      :    OnOffItem(H,Menu3.MakeOpt_wcor);      RETURN 1;
   | Menu3.MakeOpt_wcrt      :    OnOffItem(H,Menu3.MakeOpt_wcrt);      RETURN 1;
   | Menu3.MakeOpt_wdel      :    OnOffItem(H,Menu3.MakeOpt_wdel);      RETURN 1;
   | Menu3.MakeOpt_wdne      :    OnOffItem(H,Menu3.MakeOpt_wdne);      RETURN 1;
   | Menu3.MakeOpt_wdnu      :    OnOffItem(H,Menu3.MakeOpt_wdnu);      RETURN 1;
   | Menu3.MakeOpt_wetb      :    OnOffItem(H,Menu3.MakeOpt_wetb);      RETURN 1;
   | Menu3.MakeOpt_wfnd      :    OnOffItem(H,Menu3.MakeOpt_wfnd);      RETURN 1;
   | Menu3.MakeOpt_wftn      :    OnOffItem(H,Menu3.MakeOpt_wftn);      RETURN 1;
   | Menu3.MakeOpt_wnid      :    OnOffItem(H,Menu3.MakeOpt_wnid);      RETURN 1;
   | Menu3.MakeOpt_wnre      :    OnOffItem(H,Menu3.MakeOpt_wnre);      RETURN 1;
   | Menu3.MakeOpt_wnrv      :    OnOffItem(H,Menu3.MakeOpt_wnrv);      RETURN 1;
   | Menu3.MakeOpt_wntf      :    OnOffItem(H,Menu3.MakeOpt_wntf);      RETURN 1;
   | Menu3.MakeOpt_wovl      :    OnOffItem(H,Menu3.MakeOpt_wovl);      RETURN 1;
   | Menu3.MakeOpt_wovr      :    OnOffItem(H,Menu3.MakeOpt_wovr);      RETURN 1;
   | Menu3.MakeOpt_wpcv      :    OnOffItem(H,Menu3.MakeOpt_wpcv);      RETURN 1;
   | Menu3.MakeOpt_wpic      :    OnOffItem(H,Menu3.MakeOpt_wpic);      RETURN 1;
   | Menu3.MakeOpt_wpin      :    OnOffItem(H,Menu3.MakeOpt_wpin);      RETURN 1;
   | Menu3.MakeOpt_wpnd      :    OnOffItem(H,Menu3.MakeOpt_wpnd);      RETURN 1;
   | Menu3.MakeOpt_wpnu      :    OnOffItem(H,Menu3.MakeOpt_wpnu);      RETURN 1;
   | Menu3.MakeOpt_wprg      :    OnOffItem(H,Menu3.MakeOpt_wprg);      RETURN 1;
   | Menu3.MakeOpt_wral      :    OnOffItem(H,Menu3.MakeOpt_wral);      RETURN 1;
   | Menu3.MakeOpt_wrfp      :    OnOffItem(H,Menu3.MakeOpt_wrfp);      RETURN 1;
   | Menu3.MakeOpt_wsto      :    OnOffItem(H,Menu3.MakeOpt_wsto);      RETURN 1;
   | Menu3.MakeOpt_wtxt      :    OnOffItem(H,Menu3.MakeOpt_wtxt);      RETURN 1;
   | Menu3.MakeOpt_wubd      :    OnOffItem(H,Menu3.MakeOpt_wubd);      RETURN 1;
   | Menu3.MakeOpt_wvnu      :    OnOffItem(H,Menu3.MakeOpt_wvnu);      RETURN 1;
   | Menu3.MakeOpt__speed    :    OnOffItem(H,Menu3.MakeOpt__speed);    RETURN 1;
   | Menu3.MemModel          :    MemModel:=(MemModel+1) AND 7;
                                  Toggler(H,Menu3.MemModel,MemModel,"small@compact@medium@large@xlarge@mthread@overlay@dynalink");
                                  RETURN 1;
   | Menu3.No_Of_Backups     :    WrLab("No_Of_Backups");
   | Menu3.PickFile          :    WrLab("PickFile");
   | Menu3.Print             :    WrLab("Print");
   | Menu3.PrintSet          :    WrLab("PrintSet");
   | Menu3.ProjEdit          :    WrLab("ProjEdit");
   | Menu3.ProjNew           :    WrLab("ProjNew");
   | Menu3.Quit              :    WrLab("Quit");
   | Menu3.Red_Edit          :    WrLab("Red_Edit");
   | Menu3.Review_Screen     :    WrLab("Review_Screen");
   | Menu3.RunOpt_A          :    OnOffItem(H,Menu3.RunOpt_A); RETURN 1;
   | Menu3.RunOpt_S          :    OnOffItem(H,Menu3.RunOpt_S); RETURN 1;
   | Menu3.RunOpt_T          :    OnOffItem(H,Menu3.RunOpt_T); RETURN 1;
   | Menu3.SaveAllF          :    WrLab("SaveAllF");
   | Menu3.SaveFile          :    WrLab("SaveFile");
   | Menu3.SaveFile2         :    WrLab("SaveFile2");
   | Menu3.Save_All_Files    :    WrLab("Save_All_Files");
   | Menu3.Save_Config_File  :    WrLab("Save_Config_File");
   | Menu3.Save_File         :    WrLab("Save_File");
   | Menu3.Save_Macs         :    WrLab("Save_Macs");
   | Menu3.ScanCodes         :    WrLab("ScanCodes");
   | Menu3.Search_List       :    WrLab("Search_List");
   | Menu3.Toggle_RO         :    OnOffItem(H,Menu3.Toggle_RO); RETURN 1;
   | Menu3.Top_Scroll_Zone   :    WrLab("Top_Scroll_Zone");
   | Menu3.View_File         :    WrLab("View_File");
   | Menu3.WildSearch        :    WrLab("WildSearch");

   END;
RETURN 0 ;
END DoPull;

PROCEDURE Select(InCode,H:CARDINAL):CARDINAL;
(* Called when you move over a selectable item. pulldown menu version *)

BEGIN
 Window.Use(Window.FullScreen);
    CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu3.Bottom_Scroll_Zone:    WrSelect("Bottom_Scroll_Zone");
   | Menu3.Calculator        :    WrSelect("Calculator");
   | Menu3.ChangeDir         :    WrSelect("ChangeDir");
   | Menu3.Command_Line      :    WrSelect("Command_Line");
   | Menu3.Default_Extensions:    WrSelect("Default_Extensions");
   | Menu3.Default_Filenames :    WrSelect("Default_Filenames:");
   | Menu3.Directory         :    WrSelect("Directory");
   | Menu3.DOSShell          :    WrSelect("DOSShell");
   | Menu3.EdDelEndLine      :    WrSelect("EdDelEndLine");
   | Menu3.EdEndFile         :    WrSelect("EdEndFile");
   | Menu3.EdEndLine         :    WrSelect("EdEndLine");
   | Menu3.EdEndScreen       :    WrSelect("EdEndScreen");
   | Menu3.EdFind            :    WrSelect("EdFind");
   | Menu3.EdGotoBegin_Block :    WrSelect("EdGotoBegin_Block");
   | Menu3.EdGotoEnd_Block   :    WrSelect("EdGotoEnd_Block");
   | Menu3.EdGotoLine        :    WrSelect("EdGotoLine");
   | Menu3.EdGotoM1          :    WrSelect("EdGotoM1");
   | Menu3.EdGotoM2          :    WrSelect("EdGotoM2");
   | Menu3.EdLoadFile        :    WrSelect("EdLoadFile");
   | Menu3.EdLoadFRO         :    WrSelect("EdLoadFRO");
   | Menu3.EdOptC            :    WrSelect("EdOptC");
   | Menu3.EdOptI            :    WrSelect("EdOptI");
   | Menu3.EdOptT            :    WrSelect("EdOptT");
   | Menu3.EdOptU            :    WrSelect("EdOptU");
   | Menu3.EdOptV            :    WrSelect("EdOptV");
   | Menu3.EdOpt_A           :    WrSelect("EdOpt_A");
   | Menu3.EdPrevPosition    :    WrSelect("EdPrevPosition");
   | Menu3.EdReplace         :    WrSelect("EdReplace");
   | Menu3.EdRestoreLine     :    WrSelect("EdRestoreLine");
   | Menu3.EdStartFile       :    WrSelect("EdStartFile");
   | Menu3.EdStartLine       :    WrSelect("EdStartLine");
   | Menu3.EdStartScreen     :    WrSelect("EdStartScreen");
   | Menu3.EdWriteFile       :    WrSelect("EdWriteFile");
   | Menu3.Ed_Begin_Block    :    WrSelect("Ed_Begin_Block");
   | Menu3.Ed_Copy_Block     :    WrSelect("Ed_Copy_Block");
   | Menu3.Ed_Del_Block      :    WrSelect("Ed_Del_Block");
   | Menu3.Ed_End_Block      :    WrSelect("Ed_End_Block");
   | Menu3.Ed_Get_Block      :    WrSelect("Ed_Get_Block");
   | Menu3.Ed_Hide_Block     :    WrSelect("Ed_Hide_Block");
   | Menu3.Ed_Indent_Block   :    WrSelect("Ed_Indent_Block");
   | Menu3.Ed_Mark_Line      :    WrSelect("Ed_Mark_Line");
   | Menu3.Ed_Mark_Word      :    WrSelect("Ed_Mark_Word");
   | Menu3.Ed_Move_Block     :    WrSelect("Ed_Move_Block");
   | Menu3.Ed_Print_Block    :    WrSelect("Ed_Print_Block");
   | Menu3.Ed_Quit           :    WrSelect("Ed_Quit");
   | Menu3.Ed_Read_Block     :    WrSelect("Ed_Read_Block");
   | Menu3.Ed_Set_M1         :    WrSelect("Ed_Set_M1");
   | Menu3.Ed_Set_M2         :    WrSelect("Ed_Set_M2");
   | Menu3.Ed_Tab_Width      :    WrSelect("Ed_Tab_Width");
   | Menu3.Ed_Undo           :    WrSelect("Ed_Undo");
   | Menu3.Ed_Write_Block    :    WrSelect("Ed_Write_Block");
   | Menu3.EnvOpt_C          :    WrSelect("EnvOpt_C");
   | Menu3.EnvOpt_D          :    WrSelect("EnvOpt_D");
   | Menu3.EnvOpt_E          :    WrSelect("EnvOpt_E");
   | Menu3.EnvOpt_H          :    WrSelect("EnvOpt_H");
   | Menu3.EnvOpt_L          :    WrSelect("EnvOpt_L");
   | Menu3.EnvOpt_M          :    WrSelect("EnvOpt_M");
   | Menu3.EnvOpt_N          :    WrSelect("EnvOpt_N");
   | Menu3.EnvOpt_Q          :    WrSelect("EnvOpt_Q");
   | Menu3.EnvOpt_R          :    WrSelect("EnvOpt_R");
   | Menu3.EnvOpt_S          :    WrSelect("EnvOpt_S");
   | Menu3.EnvOpt_S2         :    WrSelect("EnvOpt_S2");
   | Menu3.EnvOpt_U          :    WrSelect("EnvOpt_U");
   | Menu3.EnvOpt_V          :    WrSelect("EnvOpt_V");
   | Menu3.EnvOpt_W          :    WrSelect("EnvOpt_W");
   | Menu3.Execute           :    WrSelect("Execute");
   | Menu3.Find_Error        :    WrSelect("Find_Error");
   | Menu3.Help              :    WrSelect("Help");
   | Menu3.Info              :    WrSelect("Info");
   | Menu3.LoadFile          :    WrSelect("LoadFile");
   | Menu3.LoadF_RO          :    WrSelect("LoadF_RO");
   | Menu3.Load_Config_File  :    WrSelect("Load_Config_File");
   | Menu3.Load_Macs         :    WrSelect("Load_Macs");
   | Menu3.Load_Red_File     :    WrSelect("Load_Red_File");
   | Menu3.Locate_File       :    WrSelect("Locate_File");
   | Menu3.MakeOptSystem     :    WrSelect("MakeOptSystem");
   | Menu3.MakeOptTarget     :    WrSelect("MakeOptTarget");
   | Menu3.MakeOptvid        :    WrSelect("MakeOptvid");
   | Menu3.MakeOpt_alias     :    WrSelect("MakeOpt_alias");
   | Menu3.MakeOpt_ansi      :    WrSelect("MakeOpt_ansi");
   | Menu3.MakeOpt_bit_opr   :    WrSelect("MakeOpt_bit_opr");
   | Menu3.MakeOpt_case      :    WrSelect("MakeOpt_case");
   | Menu3.MakeOpt_const     :    WrSelect("MakeOpt_const");
   | Menu3.MakeOpt_copro     :    WrSelect("MakeOpt_copro");
   | Menu3.MakeOpt_cpu       :    WrSelect("MakeOpt_cpu");
   | Menu3.MakeOpt_field     :    WrSelect("MakeOpt_field");
   | Menu3.MakeOpt_guard     :    WrSelect("MakeOpt_guard");
   | Menu3.MakeOpt_incl_cmt  :    WrSelect("MakeOpt_incl_cmt");
   | Menu3.MakeOpt_index     :    WrSelect("MakeOpt_index");
   | Menu3.MakeOpt_iso       :    WrSelect("MakeOpt_iso");
   | Menu3.MakeOpt_jpi       :    WrSelect("MakeOpt_jpi");
   | Menu3.MakeOpt_jump      :    WrSelect("MakeOpt_jump");
   | Menu3.MakeOpt_lang_ext  :    WrSelect("MakeOpt_lang_ext");
   | Menu3.MakeOpt_loop      :    WrSelect("MakeOpt_loop");
   | Menu3.MakeOpt_map       :    WrSelect("MakeOpt_map");
   | Menu3.MakeOpt_min_line  :    WrSelect("MakeOpt_min_line");
   | Menu3.MakeOpt_nest_cmt  :    WrSelect("MakeOpt_nest_cmt");
   | Menu3.MakeOpt_nil_ptr   :    WrSelect("MakeOpt_nil_ptr");
   | Menu3.MakeOpt_overflow  :    WrSelect("MakeOpt_overflow");
   | Menu3.MakeOpt_peep      :    WrSelect("MakeOpt_peep");
   | Menu3.MakeOpt_pre_proc  :    WrSelect("MakeOpt_pre_proc");
   | Menu3.MakeOpt_prototypes:    WrSelect("MakeOpt_prototypes");
   | Menu3.MakeOpt_range     :    WrSelect("MakeOpt_range");
   | Menu3.MakeOpt_regass    :    WrSelect("MakeOpt_regass");
   | Menu3.MakeOpt_share_c   :    WrSelect("MakeOpt_share_c");
   | Menu3.MakeOpt_smart_link:    WrSelect("MakeOpt_smart_link");
   | Menu3.MakeOpt_smart_m   :    WrSelect("MakeOpt_smart_m");
   | Menu3.MakeOpt_stack     :    WrSelect("MakeOpt_stack");
   | Menu3.MakeOpt_stk_frame :    WrSelect("MakeOpt_stk_frame");
   | Menu3.MakeOpt_subexpr   :    WrSelect("MakeOpt_subexpr");
   | Menu3.MakeOpt_uns_char  :    WrSelect("MakeOpt_uns_char");
   | Menu3.MakeOpt_wacc      :    WrSelect("MakeOpt_wacc");
   | Menu3.MakeOpt_wait      :    WrSelect("MakeOpt_wait");
   | Menu3.MakeOpt_watr      :    WrSelect("MakeOpt_watr");
   | Menu3.MakeOpt_wcic      :    WrSelect("MakeOpt_wcic");
   | Menu3.MakeOpt_wcld      :    WrSelect("MakeOpt_wcld");
   | Menu3.MakeOpt_wclt      :    WrSelect("MakeOpt_wclt");
   | Menu3.MakeOpt_wcne      :    WrSelect("MakeOpt_wcne");
   | Menu3.MakeOpt_wcor      :    WrSelect("MakeOpt_wcor");
   | Menu3.MakeOpt_wcrt      :    WrSelect("MakeOpt_wcrt");
   | Menu3.MakeOpt_wdel      :    WrSelect("MakeOpt_wdel");
   | Menu3.MakeOpt_wdne      :    WrSelect("MakeOpt_wdne");
   | Menu3.MakeOpt_wdnu      :    WrSelect("MakeOpt_wdnu");
   | Menu3.MakeOpt_wetb      :    WrSelect("MakeOpt_wetb");
   | Menu3.MakeOpt_wfnd      :    WrSelect("MakeOpt_wfnd");
   | Menu3.MakeOpt_wftn      :    WrSelect("MakeOpt_wftn");
   | Menu3.MakeOpt_wnid      :    WrSelect("MakeOpt_wnid");
   | Menu3.MakeOpt_wnre      :    WrSelect("MakeOpt_wnre");
   | Menu3.MakeOpt_wnrv      :    WrSelect("MakeOpt_wnrv");
   | Menu3.MakeOpt_wntf      :    WrSelect("MakeOpt_wntf");
   | Menu3.MakeOpt_wovl      :    WrSelect("MakeOpt_wovl");
   | Menu3.MakeOpt_wovr      :    WrSelect("MakeOpt_wovr");
   | Menu3.MakeOpt_wpcv      :    WrSelect("MakeOpt_wpcv");
   | Menu3.MakeOpt_wpic      :    WrSelect("MakeOpt_wpic");
   | Menu3.MakeOpt_wpin      :    WrSelect("MakeOpt_wpin");
   | Menu3.MakeOpt_wpnd      :    WrSelect("MakeOpt_wpnd");
   | Menu3.MakeOpt_wpnu      :    WrSelect("MakeOpt_wpnu");
   | Menu3.MakeOpt_wprg      :    WrSelect("MakeOpt_wprg");
   | Menu3.MakeOpt_wral      :    WrSelect("MakeOpt_wral");
   | Menu3.MakeOpt_wrfp      :    WrSelect("MakeOpt_wrfp");
   | Menu3.MakeOpt_wsto      :    WrSelect("MakeOpt_wsto");
   | Menu3.MakeOpt_wtxt      :    WrSelect("MakeOpt_wtxt");
   | Menu3.MakeOpt_wubd      :    WrSelect("MakeOpt_wubd");
   | Menu3.MakeOpt_wvnu      :    WrSelect("MakeOpt_wvnu");
   | Menu3.MakeOpt__speed    :    WrSelect("MakeOpt__speed");
   | Menu3.MemModel          :    WrSelect("MemModel");
   | Menu3.No_Of_Backups     :    WrSelect("No_Of_Backups");
   | Menu3.PickFile          :    WrSelect("PickFile");
   | Menu3.Print             :    WrSelect("Print");
   | Menu3.PrintSet          :    WrSelect("PrintSet");
   | Menu3.ProjEdit          :    WrSelect("ProjEdit");
   | Menu3.ProjNew           :    WrSelect("ProjNew");
   | Menu3.Quit              :    WrSelect("Quit");
   | Menu3.Red_Edit          :    WrSelect("Red_Edit");
   | Menu3.Review_Screen     :    WrSelect("Review_Screen");
   | Menu3.RunOpt_A          :    WrSelect("RunOpt_A");
   | Menu3.RunOpt_S          :    WrSelect("RunOpt_S");
   | Menu3.RunOpt_T          :    WrSelect("RunOpt_T");
   | Menu3.SaveAllF          :    WrSelect("SaveAllF");
   | Menu3.SaveFile          :    WrSelect("SaveFile");
   | Menu3.SaveFile2         :    WrSelect("SaveFile2");
   | Menu3.Save_All_Files    :    WrSelect("Save_All_Files");
   | Menu3.Save_Config_File  :    WrSelect("Save_Config_File");
   | Menu3.Save_File         :    WrSelect("Save_File");
   | Menu3.Save_Macs         :    WrSelect("Save_Macs");
   | Menu3.ScanCodes         :    WrSelect("ScanCodes");
   | Menu3.Search_List       :    WrSelect("Search_List");
   | Menu3.Toggle_RO         :    WrSelect("Toggle_RO");
   | Menu3.Top_Scroll_Zone   :    WrSelect("Top_Scroll_Zone");
   | Menu3.View_File         :    WrSelect("View_File");
   | Menu3.WildSearch        :    WrSelect("WildSearch");
   END;
RETURN 0 ;
END Select;

PROCEDURE Help(InCode,H:CARDINAL):CARDINAL;
(* Called when help is pressed on a pulldown menuitem *)

BEGIN
   CASE InCode OF
   | MAX(CARDINAL)  : RETURN 0;
   | Menu3.Bottom_Scroll_Zone:    WrHelpSys(SetupOptions);
   | Menu3.Calculator        :    WrHelp("Calculator");
   | Menu3.ChangeDir         :    WrHelp("ChangeDir");
   | Menu3.Command_Line      :    WrHelp("Command_Line");
   | Menu3.Default_Extensions:    WrHelp("Default_Extensions");
   | Menu3.Default_Filenames :    WrHelp("Default_Filenames:");
   | Menu3.Directory         :    WrHelp("Directory");
   | Menu3.DOSShell          :    WrHelp("DOSShell");
   | Menu3.EdDelEndLine      :    WrHelp("EdDelEndLine");
   | Menu3.EdEndFile         :    WrHelp("EdEndFile");
   | Menu3.EdEndLine         :    WrHelp("EdEndLine");
   | Menu3.EdEndScreen       :    WrHelp("EdEndScreen");
   | Menu3.EdFind            :    WrHelp("EdFind");
   | Menu3.EdGotoBegin_Block :    WrHelp("EdGotoBegin_Block");
   | Menu3.EdGotoEnd_Block   :    WrHelp("EdGotoEnd_Block");
   | Menu3.EdGotoLine        :    WrHelp("EdGotoLine");
   | Menu3.EdGotoM1          :    WrHelp("EdGotoM1");
   | Menu3.EdGotoM2          :    WrHelp("EdGotoM2");
   | Menu3.EdLoadFile        :    WrHelp("EdLoadFile");
   | Menu3.EdLoadFRO         :    WrHelp("EdLoadFRO");
   | Menu3.EdOptC            :    WrHelp("EdOptC");
   | Menu3.EdOptI            :    WrHelp("EdOptI");
   | Menu3.EdOptT            :    WrHelp("EdOptT");
   | Menu3.EdOptU            :    WrHelp("EdOptU");
   | Menu3.EdOptV            :    WrHelp("EdOptV");
   | Menu3.EdOpt_A           :    WrHelp("EdOpt_A");
   | Menu3.EdPrevPosition    :    WrHelp("EdPrevPosition");
   | Menu3.EdReplace         :    WrHelp("EdReplace");
   | Menu3.EdRestoreLine     :    WrHelp("EdRestoreLine");
   | Menu3.EdStartFile       :    WrHelp("EdStartFile");
   | Menu3.EdStartLine       :    WrHelp("EdStartLine");
   | Menu3.EdStartScreen     :    WrHelp("EdStartScreen");
   | Menu3.EdWriteFile       :    WrHelp("EdWriteFile");
   | Menu3.Ed_Begin_Block    :    WrHelp("Ed_Begin_Block");
   | Menu3.Ed_Copy_Block     :    WrHelp("Ed_Copy_Block");
   | Menu3.Ed_Del_Block      :    WrHelp("Ed_Del_Block");
   | Menu3.Ed_End_Block      :    WrHelp("Ed_End_Block");
   | Menu3.Ed_Get_Block      :    WrHelp("Ed_Get_Block");
   | Menu3.Ed_Hide_Block     :    WrHelp("Ed_Hide_Block");
   | Menu3.Ed_Indent_Block   :    WrHelp("Ed_Indent_Block");
   | Menu3.Ed_Mark_Line      :    WrHelp("Ed_Mark_Line");
   | Menu3.Ed_Mark_Word      :    WrHelp("Ed_Mark_Word");
   | Menu3.Ed_Move_Block     :    WrHelp("Ed_Move_Block");
   | Menu3.Ed_Print_Block    :    WrHelp("Ed_Print_Block");
   | Menu3.Ed_Quit           :    WrHelp("Ed_Quit");
   | Menu3.Ed_Read_Block     :    WrHelp("Ed_Read_Block");
   | Menu3.Ed_Set_M1         :    WrHelp("Ed_Set_M1");
   | Menu3.Ed_Set_M2         :    WrHelp("Ed_Set_M2");
   | Menu3.Ed_Tab_Width      :    WrHelp("Ed_Tab_Width");
   | Menu3.Ed_Undo           :    WrHelp("Ed_Undo");
   | Menu3.Ed_Write_Block    :    WrHelp("Ed_Write_Block");
   | Menu3.EnvOpt_C          :    WrHelp("EnvOpt_C");
   | Menu3.EnvOpt_D          :    WrHelp("EnvOpt_D");
   | Menu3.EnvOpt_E          :    WrHelp("EnvOpt_E");
   | Menu3.EnvOpt_H          :    WrHelp("EnvOpt_H");
   | Menu3.EnvOpt_L          :    WrHelp("EnvOpt_L");
   | Menu3.EnvOpt_M          :    WrHelp("EnvOpt_M");
   | Menu3.EnvOpt_N          :    WrHelp("EnvOpt_N");
   | Menu3.EnvOpt_Q          :    WrHelp("EnvOpt_Q");
   | Menu3.EnvOpt_R          :    WrHelp("EnvOpt_R");
   | Menu3.EnvOpt_S          :    WrHelp("EnvOpt_S");
   | Menu3.EnvOpt_S2         :    WrHelp("EnvOpt_S2");
   | Menu3.EnvOpt_U          :    WrHelp("EnvOpt_U");
   | Menu3.EnvOpt_V          :    WrHelp("EnvOpt_V");
   | Menu3.EnvOpt_W          :    WrHelp("EnvOpt_W");
   | Menu3.Execute           :    WrHelp("Execute");
   | Menu3.Find_Error        :    WrHelp("Find_Error");
   | Menu3.Help              :    WrHelp("Help");
   | Menu3.Info              :    WrHelp("Info");
   | Menu3.LoadFile          :    WrHelp("LoadFile");
   | Menu3.LoadF_RO          :    WrHelp("LoadF_RO");
   | Menu3.Load_Config_File  :    WrHelp("Load_Config_File");
   | Menu3.Load_Macs         :    WrHelp("Load_Macs");
   | Menu3.Load_Red_File     :    WrHelp("Load_Red_File");
   | Menu3.Locate_File       :    WrHelp("Locate_File");
   | Menu3.MakeOptSystem     :    WrHelp("MakeOptSystem");
   | Menu3.MakeOptTarget     :    WrHelp("MakeOptTarget");
   | Menu3.MakeOptvid        :    WrHelp("MakeOptvid");
   | Menu3.MakeOpt_alias     :    WrHelp("MakeOpt_alias");
   | Menu3.MakeOpt_ansi      :    WrHelp("MakeOpt_ansi");
   | Menu3.MakeOpt_bit_opr   :    WrHelp("MakeOpt_bit_opr");
   | Menu3.MakeOpt_case      :    WrHelp("MakeOpt_case");
   | Menu3.MakeOpt_const     :    WrHelp("MakeOpt_const");
   | Menu3.MakeOpt_copro     :    WrHelp("MakeOpt_copro");
   | Menu3.MakeOpt_cpu       :    WrHelp("MakeOpt_cpu");
   | Menu3.MakeOpt_field     :    WrHelp("MakeOpt_field");
   | Menu3.MakeOpt_guard     :    WrHelp("MakeOpt_guard");
   | Menu3.MakeOpt_incl_cmt  :    WrHelp("MakeOpt_incl_cmt");
   | Menu3.MakeOpt_index     :    WrHelp("MakeOpt_index");
   | Menu3.MakeOpt_iso       :    WrHelp("MakeOpt_iso");
   | Menu3.MakeOpt_jpi       :    WrHelp("MakeOpt_jpi");
   | Menu3.MakeOpt_jump      :    WrHelp("MakeOpt_jump");
   | Menu3.MakeOpt_lang_ext  :    WrHelp("MakeOpt_lang_ext");
   | Menu3.MakeOpt_loop      :    WrHelp("MakeOpt_loop");
   | Menu3.MakeOpt_map       :    WrHelp("MakeOpt_map");
   | Menu3.MakeOpt_min_line  :    WrHelp("MakeOpt_min_line");
   | Menu3.MakeOpt_nest_cmt  :    WrHelp("MakeOpt_nest_cmt");
   | Menu3.MakeOpt_nil_ptr   :    WrHelp("MakeOpt_nil_ptr");
   | Menu3.MakeOpt_overflow  :    WrHelp("MakeOpt_overflow");
   | Menu3.MakeOpt_peep      :    WrHelp("MakeOpt_peep");
   | Menu3.MakeOpt_pre_proc  :    WrHelp("MakeOpt_pre_proc");
   | Menu3.MakeOpt_prototypes:    WrHelp("MakeOpt_prototypes");
   | Menu3.MakeOpt_range     :    WrHelp("MakeOpt_range");
   | Menu3.MakeOpt_regass    :    WrHelp("MakeOpt_regass");
   | Menu3.MakeOpt_share_c   :    WrHelp("MakeOpt_share_c");
   | Menu3.MakeOpt_smart_link:    WrHelp("MakeOpt_smart_link");
   | Menu3.MakeOpt_smart_m   :    WrHelp("MakeOpt_smart_m");
   | Menu3.MakeOpt_stack     :    WrHelp("MakeOpt_stack");
   | Menu3.MakeOpt_stk_frame :    WrHelp("MakeOpt_stk_frame");
   | Menu3.MakeOpt_subexpr   :    WrHelp("MakeOpt_subexpr");
   | Menu3.MakeOpt_uns_char  :    WrHelp("MakeOpt_uns_char");
   | Menu3.MakeOpt_wacc      :    WrHelp("MakeOpt_wacc");
   | Menu3.MakeOpt_wait      :    WrHelp("MakeOpt_wait");
   | Menu3.MakeOpt_watr      :    WrHelp("MakeOpt_watr");
   | Menu3.MakeOpt_wcic      :    WrHelp("MakeOpt_wcic");
   | Menu3.MakeOpt_wcld      :    WrHelp("MakeOpt_wcld");
   | Menu3.MakeOpt_wclt      :    WrHelp("MakeOpt_wclt");
   | Menu3.MakeOpt_wcne      :    WrHelp("MakeOpt_wcne");
   | Menu3.MakeOpt_wcor      :    WrHelp("MakeOpt_wcor");
   | Menu3.MakeOpt_wcrt      :    WrHelp("MakeOpt_wcrt");
   | Menu3.MakeOpt_wdel      :    WrHelp("MakeOpt_wdel");
   | Menu3.MakeOpt_wdne      :    WrHelp("MakeOpt_wdne");
   | Menu3.MakeOpt_wdnu      :    WrHelp("MakeOpt_wdnu");
   | Menu3.MakeOpt_wetb      :    WrHelp("MakeOpt_wetb");
   | Menu3.MakeOpt_wfnd      :    WrHelp("MakeOpt_wfnd");
   | Menu3.MakeOpt_wftn      :    WrHelp("MakeOpt_wftn");
   | Menu3.MakeOpt_wnid      :    WrHelp("MakeOpt_wnid");
   | Menu3.MakeOpt_wnre      :    WrHelp("MakeOpt_wnre");
   | Menu3.MakeOpt_wnrv      :    WrHelp("MakeOpt_wnrv");
   | Menu3.MakeOpt_wntf      :    WrHelp("MakeOpt_wntf");
   | Menu3.MakeOpt_wovl      :    WrHelp("MakeOpt_wovl");
   | Menu3.MakeOpt_wovr      :    WrHelp("MakeOpt_wovr");
   | Menu3.MakeOpt_wpcv      :    WrHelp("MakeOpt_wpcv");
   | Menu3.MakeOpt_wpic      :    WrHelp("MakeOpt_wpic");
   | Menu3.MakeOpt_wpin      :    WrHelp("MakeOpt_wpin");
   | Menu3.MakeOpt_wpnd      :    WrHelp("MakeOpt_wpnd");
   | Menu3.MakeOpt_wpnu      :    WrHelp("MakeOpt_wpnu");
   | Menu3.MakeOpt_wprg      :    WrHelp("MakeOpt_wprg");
   | Menu3.MakeOpt_wral      :    WrHelp("MakeOpt_wral");
   | Menu3.MakeOpt_wrfp      :    WrHelp("MakeOpt_wrfp");
   | Menu3.MakeOpt_wsto      :    WrHelp("MakeOpt_wsto");
   | Menu3.MakeOpt_wtxt      :    WrHelp("MakeOpt_wtxt");
   | Menu3.MakeOpt_wubd      :    WrHelp("MakeOpt_wubd");
   | Menu3.MakeOpt_wvnu      :    WrHelp("MakeOpt_wvnu");
   | Menu3.MakeOpt__speed    :    WrHelp("MakeOpt__speed");
   | Menu3.MemModel          :    WrHelp("MemModel");
   | Menu3.No_Of_Backups     :    WrHelp("No_Of_Backups");
   | Menu3.PickFile          :    WrHelp("PickFile");
   | Menu3.Print             :    WrHelp("Print");
   | Menu3.PrintSet          :    WrHelp("PrintSet");
   | Menu3.ProjEdit          :    WrHelp("ProjEdit");
   | Menu3.ProjNew           :    WrHelp("ProjNew");
   | Menu3.Quit              :    WrHelp("Quit");
   | Menu3.Red_Edit          :    WrHelp("Red_Edit");
   | Menu3.Review_Screen     :    WrHelp("Review_Screen");
   | Menu3.RunOpt_A          :    WrHelp("RunOpt_A");
   | Menu3.RunOpt_S          :    WrHelp("RunOpt_S");
   | Menu3.RunOpt_T          :    WrHelp("RunOpt_T");
   | Menu3.SaveAllF          :    WrHelp("SaveAllF");
   | Menu3.SaveFile          :    WrHelp("SaveFile");
   | Menu3.SaveFile2         :    WrHelp("SaveFile2");
   | Menu3.Save_All_Files    :    WrHelp("Save_All_Files");
   | Menu3.Save_Config_File  :    WrHelp("Save_Config_File");
   | Menu3.Save_File         :    WrHelp("Save_File");
   | Menu3.Save_Macs         :    WrHelp("Save_Macs");
   | Menu3.ScanCodes         :    WrHelp("ScanCodes");
   | Menu3.Search_List       :    WrHelp("Search_List");
   | Menu3.Toggle_RO         :    WrHelp("Toggle_RO");
   | Menu3.Top_Scroll_Zone   :    WrHelp("Top_Scroll_Zone");
   | Menu3.View_File         :    WrHelp("View_File");
   | Menu3.WildSearch        :    WrHelp("WildSearch");
   END;
RETURN 0 ;
END Help;

PROCEDURE Displ();
(* Creates background*)

VAR I : CARDINAL;
    S : ARRAY[0..80] OF CHAR;

BEGIN
 Window.TextColor(Window.LightGray);
 FOR I:= 3 TO 22 DO
  Window.GotoXY(1,I); IO.WrCharRep(CHR(177),80);
  END;
 Window.TextColor(Window.Blue);
 Window.GotoXY(1,2);  IO.WrCharRep("",80);
 Window.GotoXY(1,23); IO.WrCharRep("",80);
 Window.TextColor(Window.Color(4));
 Window.GotoXY(2,24); IO.WrCharRep(" ",77);
 Window.GotoXY((78-Length(StatusLine)) DIV 2+1,24);
 IO.WrStr(StatusLine);
END Displ;

 (* The colorscheme in below definition is horrible, but all colors are
      different, so that all selectable colors can be seen.
      pulldown menu demo. *)

(*                    KeyCol,             (* Color of predefined keys*)
                    Text,               (* Color of normal text (in menu) *)
                    InCol,              (* Background color menu when not lit*)
                    HiCol,              (* textcolor menu when lit*)
                    HiBack,             (* background color menu when lit*)
                    Rand,               (* Color of menu's border*)
                    RandBack,           (* Background color of menu's border.*)
                    TextTop,            (* Color of Top when not lit *)
                    Top,                (* Background of Top when not lit *)
                    HiTop,              (* Textcolor of Top when lit *)
                    HiBTop : Color;     (* Background of Top when lit*)
 *)
CONST PullD= PullDef(PullDown.TopSpeedCol,  TRUE,22,DoPull,Help,Select);

VAR
    H   : PullHandle;
    I   : CARDINAL;

BEGIN
 EnableBreakCheck;                      (* Breaking with Ctrl-break possible*)

 Displ;                                 (* Create the background*)
 H:=PullOpen(PullObject(Menu3.TsPull),PullD);  (* Initialize pulldownmenu*)
 I:=GetPullKey(H,1);                    (* Operate pulldownmenu*)
 PullClose(H);                          (* Close  pulldownmenu*)
END JpiDem.
