MODULE Pas2Mod;
(*
Util for TurboPascal to Modula2 porting ,XtdLib package,
                              (C) by Marco van de Voort 1997

Don't use this program with Medium or Small, it won't work!
    (It requires more than 64k heap)

The program is useful when converting a TP program/procedure to (TopSpeed)
Modula2. It capitalizes all words in 'Keywords.lst', converts { and } to
(* and *)  and changes SHR and SHL to their M2 equivalent (<< >>)

I know, it isn't exactly state of the art, but it DOES speed up converting
sources a lot.

I put the file keywords.lst in the DOC directory. Please put it in your current
directory or the DOS-path.

NEW : Now doesn't process comments. Nested comments can sometimes get messy.
      OK:                           Wrong:
                                    {{fdsa} to} becomes {{fdsa} TO}
      {{to}}

Mixed comments {} and the modula2 variant (**) do well, as long as their not
nested.
*)

FROM Lib IMPORT Move,AddAddr,ParamStr,ParamCount,EnvironmentFind;
FROM Str IMPORT Length,CHARSET,Append,Caps,Copy,Compare,Item,CharPos,Pos;
FROM MLib IMPORT FindInPath;

IMPORT FIO,Storage,FIOR;

CONST BufSize=4096+FIO.BufferOverhead;
      OldName="File.Tmp";

TYPE StrP       = POINTER TO ARRAY[0..99] OF CHAR;
     IndexType  = ARRAY[1..1000] OF CARDINAL;
     BufType    = POINTER TO ARRAY[0..BufSize-1] OF BYTE;
     MainR      = RECORD
                   Root    : StrP;
                   Ind     : IndexType;
                   LenInd  : IndexType;
                   Big,Small:CARDINAL;
                   InArr   : CARDINAL;
                   B1,B2   : BufType;
                   END;
     PMainR     = POINTER TO MainR;


CONST NotFlushTriggers=CHARSET{"a".."z","A".."Z","0".."9"};

VAR R : PMainR;

PROCEDURE ReadFile(Name:ARRAY OF CHAR);

VAR F   : FIO.File;
    Ind : CARDINAL;
    A   : CARDINAL;
    S   : ARRAY [0..99] OF CHAR;

BEGIN
 R^.InArr:=0;                    Ind:=0;
 R^.Big:=0;                      R^.Small:=1000;
 F:=FIO.Open(Name);
 FIO.AssignBuffer(F,R^.B1^);
 LOOP
  FIO.RdStr(F,S);
  IF FIO.EOF THEN
   EXIT
   END;
  A:=Length(S);
  Caps(S);
  IF (A>0) AND ((Ind+A)<65535) THEN
   IF A<R^.Small THEN
    R^.Small:=A;
    END;
   IF A>R^.Big THEN
    R^.Big:=A;
    END;
   INC(R^.InArr);
   R^.LenInd[R^.InArr]:=A;
   R^.Ind[R^.InArr]:=Ind;
   Move(ADR(S),AddAddr(R^.Root,Ind),Length(S)+1);
   INC(Ind,A+1);
   END;
  END;
  DEC(R^.Small);
 FIO.Close(F);
END ReadFile;

PROCEDURE ParseFile(Name:ARRAY OF CHAR);

VAR F   : FIO.File;
    F2  : FIO.File;
    Buf : ARRAY[0..400] OF CHAR;
    S   : ARRAY[0..99] OF CHAR;
    C,C2: CHAR;
    Len,
    A   : CARDINAL;
    Tmp : StrP;
    By  : CARDINAL;
    Comment : BOOLEAN;


PROCEDURE Flush;

BEGIN
 IF Buf[0] # CHR(0) THEN
  FIO.WrBin(F2,Buf,Length(Buf));
  Buf[0]:=CHR(0);
  END;
END Flush;

PROCEDURE FlushStr(Ss:ARRAY OF CHAR);

BEGIN
 IF Ss[0] # CHR(0) THEN
  FIO.WrBin(F2,Ss,Length(Ss));
  END;
END FlushStr;

BEGIN
 By:=0;
 Comment:=FALSE; (* False= not within quotation marks *)
 F:=FIO.Open(Name);
 FIO.AssignBuffer(F,R^.B1^);
 F2:=FIO.Create(OldName);
 FIO.AssignBuffer(F2,R^.B2^);
 Buf[0]:=CHR(0);
 LOOP
  C:=FIO.RdChar(F);
  IF C="(" THEN
   Flush;
   C2:=FIO.RdChar(F);
   IF C2="*" THEN
    Comment:=TRUE;
    FlushStr("(*");
    C:="";
   ELSE
    FlushStr("(");
    C:=C2;
    END;
   END;
  IF C="*" THEN
   Flush;
   C2:=FIO.RdChar(F);
   IF C2=")" THEN
    Comment:=FALSE;
    FlushStr("*)");
    C:="";
   ELSE
    FlushStr("*");
    C:=C2;
    END;
   END;
  INC(By);
  IF FIO.EOF THEN
   EXIT
   END;

  IF C IN NotFlushTriggers THEN
   Append(Buf,C);
   IF Length(Buf)>R^.Big THEN
    Flush;
    END;
  ELSE
   Len:=Length(Buf);
   IF Len>R^.Small THEN
    IF NOT Comment THEN
     Copy(S,Buf);
     Caps(S);

     IF Len=3 THEN
      IF Compare(S,"SHL")=0 THEN
       Buf:="<<";
       S:="";
       Flush;
       END;
      IF Compare(S,"SHR")=0 THEN
       Buf:=">>";
       S:="";
       Flush;
       END;
      END;
     FOR A:= 1 TO R^.InArr DO
      IF Len=R^.LenInd[A] THEN
       Tmp:=AddAddr(R^.Root,R^.Ind[A]);
       IF Compare(S,Tmp^)=0 THEN
        Copy(Buf,S);
        END;
       END;
      END; (*For *)
     END; (* IF Len>R^ *)
    END; (* If comment*)
    Flush;
    CASE C OF
     | "{"     : Buf:="(*";
                 Comment:=TRUE;
     | "}"     : Buf:="*)";
                 Comment:=FALSE;
    ELSE
     Buf[0]:=C;
     Buf[1]:=CHR(0);
     END;
    Flush;
    END;
  END;
 FIO.Close(F);
 FIO.Close(F2);
END ParseFile;

VAR S,S2,S3 : ARRAY[0..99] OF CHAR;

BEGIN
 IF ParamCount()<1 THEN
  HALT;
  END;
 ParamStr(S,1);
 IF NOT FIO.Exists(S) THEN
  HALT;
  END;
 Storage.ALLOCATE(R,SIZE(MainR));
 IF Storage.Available(65535) THEN
  Storage.FarHeapAllocate(Storage.MainHeap,R^.Root,4096);
  END;
 Storage.ALLOCATE(R^.B1,BufSize); Storage.ALLOCATE(R^.B2,BufSize);
 FindInPath("Keywords.lst",S3);
 ReadFile(S3);
 ParseFile(S);
 Copy(S2,S);
 FIOR.ChangeExtension(S2,"BAK");
 IF FIO.Exists(S2) THEN
  FIO.Erase(S2);
  END;
 FIO.Rename(S,S2);
 FIO.Rename(OldName,S);
END Pas2Mod.