MODULE TCAL;
(* Displays a calendar, per month, with scroll options and displays some
  ceremonies as a demonstation of the date capabilities of ELib/MLib.
 Demo belonging to the XtdLib package, (C) by Marco van de Voort 1996

 Could be upgraded with non-movable festivities like Christmas. But that's
 too easy:-)
 *)

FROM IO       IMPORT WrStr, RdCard, WrLn, WrCard, WrChar, WrCharRep;
FROM ELib     IMPORT DOW,LeapYr,GetKey,PhaseOfMoon;
FROM MLib     IMPORT MovableCeremony,Ceremony;
FROM Lib      IMPORT DayType,GetDate;

IMPORT Crt;

TYPE (*Most of following types copied from ELib, see Buglist.txt for the
     reason why *)

   Array12Type = ARRAY [1..12] OF CARDINAL;
   MonthStr    = ARRAY[1..12] OF ARRAY[0..2] OF CHAR;
   DowsStr     = ARRAY[0..6] OF ARRAY[0..2] OF CHAR;

   CerType     = ARRAY[0..11] OF ARRAY[0..15] OF CHAR;

CONST
   (* Days in month, no correction leapyears *)
   MonthDays = Array12Type(31,28,31,30,31,30,31,31,30,31,30,31);
   (* cummulative days, no correction leapyears *)
   MonthCumm = Array12Type(0,31,59,90,120,151,181,212,243,273,304,334);
   Months=MonthStr("Jan","Feb","Mar","Apr","May","Jun","Jul",
                     "Aug","Sep","Oct","Nov","Dec");

   ArrU   = 04800H;   ArrL   = 04B00H;   ArrR   = 04D00H;   ArrD   = 05000H;

   CerName=CerType("AshWednesday","GoodFriday","EasterSunday",
          "EasterMonday","AscensionDay","Whitsunday",
          "WhitsunMonday","CorpusChristiDay","RepentanceDay",
          "FirstAdvent","SecondAdvent","MothersDay");

PROCEDURE ShowMonth(year,month,day:CARDINAL);

VAR
  daysInMonth      : CARDINAL;
  wd,i,j, z          : CARDINAL;

BEGIN
   Crt.ClrScr;
   WrChar(''); WrCharRep('',22); WrChar(''); WrLn;
   WrChar(''); WrCharRep(' ',7);
   WrStr (Months[month]); WrCard(year,5);
   WrCharRep(' ', 7); WrChar(''); WrLn;
   WrChar(''); WrCharRep('',22); WrChar(''); WrLn;
   WrStr (' Su Mo Tu We Th Fr Sa '); WrLn;
   WrChar('');
   wd:=DOW(year,month,day);
   FOR i:= 1 TO wd DO
     WrStr('   ');
   END;
   z := 1;
   FOR i:=ORD(wd) TO 6 DO
     WrCard(z,3); INC(z);
   END;
   daysInMonth := MonthDays[month];
   IF (month=2) AND (LeapYr(year)) THEN
    INC (daysInMonth);
    END;
   WrStr(' '); WrLn; WrChar('');
   REPEAT
     WrCard(z, 3); INC(z);
     IF ((z+ORD(wd)-1) MOD 7 = 0) AND (z <= daysInMonth) THEN
       WrStr(' '); WrLn(); WrChar('');
     END;
   UNTIL z > daysInMonth;
   WHILE (z+ORD(wd)-1) MOD 7 # 0 DO
     WrStr('   '); INC(z);
   END;
   WrStr(' '); WrLn; WrChar(''); WrCharRep('',22); WrChar(''); WrLn;
   WrLn;
   WrStr(" left and right arrow     :  increase/decrease month"); WrLn;
   WrStr(" up   and down  arrow     :  increase/decrease year"); WrLn;
   WrStr(" x or X                   :  exit"); WrLn;
   j:=1;
   FOR i:=0 TO 11 DO
    MovableCeremony(Ceremony(i),year,wd,z);
    IF month=z THEN
     Crt.GotoXY(55,j);
     INC(j);
     WrCard(wd,-5);
     WrStr(CerName[i]);
     END;
    END;
   j:=0;
   FOR i:=0 TO MonthDays[month] DO
    IF ORD(PhaseOfMoon(year,month,i))=4 THEN
     IF j=0 THEN
      Crt.GotoXY(25,0);
      WrStr(" Full moons this month");
      END;
     Crt.GotoXY(25+(j AND 3) * 4,1+(j DIV 4));
     WrCard(i,3);
     INC(j);
     END;
    END;
END ShowMonth;

VAR Day,Month,Year : CARDINAL;
    DT             : DayType;
    Key            : CARDINAL;

BEGIN
  GetDate(Year,Month,Day,DT);
  ShowMonth(Year,Month,Day);
  REPEAT
   Key:=GetKey();
   CASE Key OF
    | ArrL : DEC (Month);
             IF Month=0 THEN
              Month:=12;
              DEC(Year);
              END;
             ShowMonth(Year,Month,Day);
    | ArrR : INC (Month);
             IF Month=13 THEN
              Month:=1;
              INC(Year);
              END;
             ShowMonth(Year,Month,Day);
   | ArrU :  DEC(Year);
             ShowMonth(Year,Month,Day);
   | ArrD :  INC(Year);
             ShowMonth(Year,Month,Day);
    END;
  UNTIL (Key=ORD("x")) OR (Key=ORD("X"));
END TCAL.
