IMPLEMENTATION MODULE MsgBase;

FROM Storage IMPORT
     (* procs *) ALLOCATE, DEALLOCATE;

IMPORT Str;

CONST
   LF = CHR( 10 );
   CR = CHR( 13 );

PROCEDURE TxtNew( S : ARRAY OF CHAR ) : PMsgTxt;
VAR
   Txt : PMsgTxt;
BEGIN
   ALLOCATE( Txt, SIZE( TMsgTxt ) );
   ALLOCATE( Txt^.TxtLine, Str.Length( S ) );
   Str.Copy( Txt^.TxtLine^, S );
   Txt^.TxtNext := NIL;
   RETURN Txt;
END TxtNew;

PROCEDURE TxtDispose( VAR Txt : PMsgTxt );
BEGIN
   IF Txt^.TxtNext # NIL THEN
      TxtDispose( Txt^.TxtNext );
   END;
   DEALLOCATE( Txt^.TxtLine, Str.Length( Txt^.TxtLine^ ) );
   DEALLOCATE( Txt, SIZE( TMsgTxt ) );
END TxtDispose;

PROCEDURE TxtAddLine( Txt : PMsgTxt; S : ARRAY OF CHAR );
BEGIN
   IF Txt^.TxtNext = NIL THEN
      Txt^.TxtNext := TxtNew( S );
   ELSE
      TxtAddLine( Txt^.TxtNext, S );
   END;
END TxtAddLine;

PROCEDURE TxtDump( Txt    : PMsgTxt;   Proc    : TDumpProc;
                   Margin : SHORTCARD; Kludges : BOOLEAN );
VAR
   Stoppen, Transfer : BOOLEAN;
   Buffer, TempStr   : ARRAY [0..255] OF CHAR;
   BufCur, BufMax    : CARDINAL;
BEGIN
   Stoppen := FALSE;
   TempStr[0] := CHR(0);
   Buffer[0] := CHR(0);
   IF Txt = NIL THEN
      Stoppen := TRUE;
   ELSE
      Str.Copy( Buffer, Txt^.TxtLine^ );
      BufCur := 0;
      BufMax := Str.Length( Buffer )-1;
   END;
   REPEAT
      Transfer := TRUE;
      WHILE Transfer DO
         IF BufCur > BufMax THEN
            IF Txt^.TxtNext # NIL THEN
               Txt := Txt^.TxtNext;
               Str.Copy( Buffer, Txt^.TxtLine^ );
               BufCur := 0;
               BufMax := Str.Length( Buffer )-1;
            ELSE
               Transfer := FALSE;
               Stoppen := TRUE;
            END;
         ELSIF Buffer[BufCur] = CR THEN
            INC( BufCur );
            Transfer := FALSE;
         ELSIF Buffer[BufCur] = LF THEN
            INC( BufCur );
         ELSIF Str.Length( TempStr ) = CARDINAL(Margin) THEN
            Transfer := FALSE;
         ELSE
            Str.Append( TempStr, Buffer[BufCur] );
            INC( BufCur );
         END;
      END;
      IF (Kludges) OR (TempStr[0]#CHR(1)) THEN
         Stoppen := Stoppen OR Proc( TempStr );
      END;
      TempStr[0] := CHR(0);
   UNTIL Stoppen;
END TxtDump;

PROCEDURE NetFirst( Dir : ARRAY OF CHAR ) : CARDINAL;
VAR
   DirName   : ARRAY [0..63] OF CHAR;
   OK, OK2   : BOOLEAN;
   D         : FIO.DirEntry;
   Number, I : CARDINAL;
   Temp      : FIO.PathTail;
BEGIN
   Number := MAX( CARDINAL );
   Str.Copy( DirName, Dir );
   Str.Append( DirName, "\*.MSG" );
   OK := FIO.ReadFirstEntry( DirName, FIO.FileAttr{FIO.hidden}, D );
   WHILE OK DO
      Str.Copy( Temp, D.Name );
      Str.Delete( Temp, Str.Length( Temp )-4, 4 );
      I := CARDINAL(Str.StrToCard( Temp, 10, OK2 ));
      IF I < Number THEN
         Number := I;
      END;
      OK := FIO.ReadNextEntry( D );
   END;
   RETURN Number;
END NetFirst;

PROCEDURE NetLast( Dir : ARRAY OF CHAR ) : CARDINAL;
VAR
   DirName   : ARRAY [0..63] OF CHAR;
   OK, OK2   : BOOLEAN;
   D         : FIO.DirEntry;
   Number, I : CARDINAL;
   Temp      : FIO.PathTail;
BEGIN
   Number := 0;
   Str.Copy( DirName, Dir );
   Str.Append( DirName, "\*.MSG" );
   OK := FIO.ReadFirstEntry( DirName, FIO.FileAttr{FIO.hidden}, D );
   WHILE OK DO
      Str.Copy( Temp, D.Name );
      Str.Delete( Temp, Str.Length( Temp )-4, 4 );
      I := CARDINAL(Str.StrToCard( Temp, 10, OK2 ));
      IF I > Number THEN
         Number := I;
      END;
      OK := FIO.ReadNextEntry( D );
   END;
   IF Number = 0 THEN
      Number := MAX( CARDINAL );
   END;
   RETURN Number;
END NetLast;

PROCEDURE NetPrev( Dir : ARRAY OF CHAR; Num : CARDINAL ) : CARDINAL;
VAR
   DirName   : ARRAY [0..63] OF CHAR;
   OK, OK2   : BOOLEAN;
   D         : FIO.DirEntry;
   Number, I : CARDINAL;
   Temp      : FIO.PathTail;
BEGIN
   Number := 0;
   Str.Copy( DirName, Dir );
   Str.Append( DirName, "\*.MSG" );
   OK := FIO.ReadFirstEntry( DirName, FIO.FileAttr{FIO.hidden}, D );
   WHILE OK DO
      Str.Copy( Temp, D.Name );
      Str.Delete( Temp, Str.Length( Temp )-4, 4 );
      I := CARDINAL(Str.StrToCard( Temp, 10, OK2 ));
      IF (I < Num) AND (I > Number) THEN
         Number := I;
      END;
      OK := FIO.ReadNextEntry( D );
   END;
   IF Number = 0 THEN
      Number := MAX( CARDINAL );
   END;
   RETURN Number;
END NetPrev;

PROCEDURE NetNext( Dir : ARRAY OF CHAR; Num : CARDINAL ) : CARDINAL;
VAR
   DirName   : ARRAY [0..63] OF CHAR;
   OK, OK2   : BOOLEAN;
   D         : FIO.DirEntry;
   Number, I : CARDINAL;
   Temp      : FIO.PathTail;
BEGIN
   Number := MAX( CARDINAL );
   Str.Copy( DirName, Dir );
   Str.Append( DirName, "\*.MSG" );
   OK := FIO.ReadFirstEntry( DirName, FIO.FileAttr{FIO.hidden}, D );
   WHILE OK DO
      Str.Copy( Temp, D.Name );
      Str.Delete( Temp, Str.Length( Temp )-4, 4 );
      I := CARDINAL(Str.StrToCard( Temp, 10, OK2 ));
      IF (I > Num) AND (I < Number) THEN
         Number := I;
      END;
      OK := FIO.ReadNextEntry( D );
   END;
   RETURN Number;
END NetNext;

PROCEDURE NetWrite( Dir : ARRAY OF CHAR; Num : CARDINAL;
                    Hdr : NetRecord;     Txt : PMsgTxt );
VAR
   DirName : ARRAY [0..63] OF CHAR;
   Temp    : FIO.PathTail;
   OK      : BOOLEAN;
   F       : FIO.File;
BEGIN
   Str.Copy( DirName, Dir );
   Str.Append( DirName, '\' );
   Str.CardToStr( LONGCARD(Num), Temp, 10, OK );
   Str.Append( DirName, Temp );
   Str.Append( DirName, ".MSG" );
   F := FIO.Create( DirName );
   FIO.WrBin( F, Hdr, SIZE( NetRecord ) );
   WHILE Txt # NIL DO
      FIO.WrBin( F, Txt^.TxtLine^, Str.Length( Txt^.TxtLine^ ) );
      Txt := Txt^.TxtNext;
   END;
   FIO.Close( F );
END NetWrite;

PROCEDURE NetRead(     Dir : ARRAY OF CHAR;     Num : CARDINAL;
                   VAR Hdr : NetRecord;     VAR Txt : PMsgTxt );
VAR
   DirName     : ARRAY [0..63] OF CHAR;
   Temp        : FIO.PathTail;
   OK          : BOOLEAN;
   bytes       : CARDINAL;
   OldOpenMode : BYTE;
   F           : FIO.File;
   Buffer      : ARRAY [0..255] OF CHAR;
BEGIN
   Str.Copy( DirName, Dir );
   Str.Append( DirName, '\' );
   Str.CardToStr( LONGCARD(Num), Temp, 10, OK );
   Str.Append( DirName, Temp );
   Str.Append( DirName, ".MSG" );
   OldOpenMode := FIO.OpenMode;         (* This is a own FIO modification of
                                           Andreas. If you use TS3.1,
                                            change this with FIO.ShareMode
                                            For msgbases, sharing is required,
                                            so don't remove it! Patch FIO
                                            yourself if you're using 1.17!*)
   FIO.OpenMode := 42H;
   F := FIO.Open( DirName );
   bytes := FIO.RdBin( F, Hdr, SIZE( NetRecord ) );
   bytes := FIO.RdBin( F, Buffer, SIZE( Buffer ) );
   Txt := TxtNew( Buffer );
   WHILE NOT FIO.EOF DO
      bytes := FIO.RdBin( F, Buffer, SIZE( Buffer ) );
      IF bytes < SIZE( Buffer ) THEN
         Buffer[bytes] := CHR(0);
      END;
      IF NOT FIO.EOF THEN
         TxtAddLine( Txt, Buffer );
      END;
   END;
   FIO.Close( F );
   FIO.OpenMode := OldOpenMode;
END NetRead;

PROCEDURE NetKill( Dir : ARRAY OF CHAR; Num : CARDINAL );
BEGIN
END NetKill;

PROCEDURE GetLastRead( Dir : ARRAY OF CHAR ) : CARDINAL;
BEGIN
   RETURN 0;
END GetLastRead;

PROCEDURE SetLastRead( Dir : ARRAY OF CHAR; Num : CARDINAL );
BEGIN
END SetLastRead;

END MsgBase.
