IMPLEMENTATION MODULE RaDev;

(* Library    : RA-Dev  version 1.0 -- RA 1.xx developement kit
   Written By : ing. A.T Reinicke
   Descript   : Procedures to read from RA 1.xx configuration files.
*)

IMPORT Tlib, FIO, Str, IO;

CONST
   NUL = CHR( 0 );

PROCEDURE FixString( VAR String    : ARRAY OF CHAR;
                         Length    : BYTE           );
VAR
   I : CARDINAL;
BEGIN
   FOR I := CARDINAL( Length ) TO SIZE( String )-1 DO
      String[I] := NUL;
   END;
END FixString;

PROCEDURE Read_RAConfig( VAR Buffer : CONFIGrecord ) : CARDINAL;
VAR
   FP     : FIO.File;
   NrRead : CARDINAL;
   FileNm : ARRAY [0..63] OF CHAR;
BEGIN
   Str.Copy( FileNm, RApath );
   Str.Append( FileNm, "CONFIG.RA" );
   FP := FIO.Open( FileNm );
   NrRead := FIO.RdBin( FP, Buffer, SIZE( Buffer ) );
   FIO.Close( FP );
   (* Fix String-termination (Turbo-compatibility) *)
   WITH Buffer DO
      FixString( MenuPath, MenuPath_len );
      FixString( TextPath, TextPath_len );
      FixString( AttachPath, AttachPath_len );
      FixString( NodelistPath, NodelistPath_len );
      FixString( MsgBasePath, MsgBasePath_len );
      FixString( SysPath, SysPath_len );
      FixString( ListPath, ListPath_len );
   END;
   RETURN NoError;
END Read_RAConfig;

PROCEDURE Read_RAFiles( VAR Buffer : ARRAY OF FILESrecord ) : CARDINAL;
VAR
   FP        : FIO.File;
   NrRead, I : CARDINAL;
   FileNm    : ARRAY [0..63] OF CHAR;
BEGIN
   Str.Copy( FileNm, RApath );
   Str.Append( FileNm, "FILES.RA" ); (* Dir uit CONFIG.RA halen !!!!! *)
   FP := FIO.Open( FileNm );
   FOR I := 0 TO 199 DO
      NrRead := FIO.RdBin( FP, Buffer[I], SIZE( Buffer[I] ) );
      WITH Buffer[I] DO
         FixString( Name, Name_len );
         FixString( FilePath, FilePath_len );
      END;
   END;
   FIO.Close( FP );
   RETURN NoError;
END Read_RAFiles;

BEGIN
   Tlib.EnvironmentFind( "RA", RApath );
   IF 0=Str.Compare( RApath, "" ) THEN
      IO.WrStr( "ERROR! - Remote Access path not defined (SET RA=)." );
      IO.WrLn;
      HALT;
   ELSIF RApath[Str.Length(RApath)-1] # "\" THEN
      Str.Append( RApath, "\" );
   END;
   Str.Caps( RApath );
END RaDev.
